import { c as J, a as K, t as j, z as $, p as ee, V as X, O as H, f as U, L as te, G as ie, i as re, a4 as ae, a1 as le, a5 as se, v as ne, a6 as he, d as oe, B as ce, b as de, q as ue, R as ge, Q as fe, a7 as Ie, r as me, e as Ne, a2 as xe, y as be, C as Fe, x as _e, a8 as Ae, Z as ye, o as Le, s as Ce, w as Se, F as ke, A as we, u as Oe } from "./index-CFW17vb1.js";
import { D as Ge } from "./DataTable-DYhXzoFM.js";
import { _ as ve } from "./Title-C_gOJvlv.js";
import { _ as ze, u as Me } from "./Tooltip-Czv48jTt.js";
import { U as pe } from "./usePrinter-19frcFuH.js";
import { _ as Te } from "./Shape-Bit--n_P.js";
import Pe from "./BaseIcon-I6DfuN0D.js";
import Ve from "./vue-ui-table-sparkline-Cgt7aEwb.js";
import Re from "./vue-ui-skeleton-RRyod9qq.js";
import { S as De } from "./Slicer-BIRZ38gw.js";
import He from "./vue-ui-accordion-B8vShfXi.js";
import { u as Z } from "./useNestedProp-HPB1YHuD.js";
import { _ as Be } from "./PackageVersion-CO2IMTO9.js";
import { P as We } from "./PenAndPaper-CnW2eqXw.js";
import { resolveComponent as R, openBlock as a, createElementBlock as s, normalizeClass as D, normalizeStyle as L, createBlock as B, createCommentVNode as c, createSlots as Ee, withCtx as P, renderSlot as k, normalizeProps as W, guardReactiveProps as E, createVNode as q, createElementVNode as u, Fragment as f, renderList as m, toDisplayString as w, mergeProps as Ye, withDirectives as qe, vModelCheckbox as Xe, createTextVNode as Ue } from "vue";
import { _ as Ze } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Je = J(), Qe = {
  name: "vue-ui-xy",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  components: {
    DataTable: Ge,
    Shape: Te,
    Title: ve,
    Tooltip: ze,
    UserOptions: pe,
    BaseIcon: Pe,
    TableSparkline: Ve,
    Skeleton: Re,
    Slicer: De,
    Accordion: He,
    PackageVersion: Be,
    PenAndPaper: We
  },
  data() {
    this.dataset.forEach((d, t) => {
      [null, void 0].includes(d.series) && this.error({
        componentName: "VueUiXy",
        type: "datasetSerieAttribute",
        property: "series (number[])",
        index: t
      });
    });
    const i = this.config.downsample && this.config.downsample.threshold ? this.config.downsample.threshold : 500, l = Math.max(...this.dataset.map((d) => this.largestTriangleThreeBucketsArray({ data: d.series, threshold: i }).length)), o = {
      start: 0,
      end: l
    };
    return {
      themePalettes: K,
      themes: j,
      slicerStep: 0,
      selectedScale: null,
      CTX: null,
      CANVAS: null,
      opacity: $,
      useSafeValues: !0,
      palette: ee,
      height: 600,
      width: 1e3,
      viewBox: "0 0 1000 600",
      clientPosition: {
        x: 0,
        y: 0
      },
      canvasClientPosition: {
        x: 0,
        y: 0
      },
      icons: {
        line: "line",
        bar: "bar",
        plot: "plot"
      },
      isAnnotator: !1,
      isFullscreen: !1,
      isPrinting: !1,
      isImaging: !1,
      isTooltip: !1,
      mutableConfig: {
        dataLabels: {
          show: !0
        },
        showTooltip: !0,
        showTable: !1,
        isStacked: !1,
        useIndividualScale: !1
      },
      selectedSerieIndex: null,
      selectedRowIndex: null,
      segregatedSeries: [],
      uniqueId: J(),
      step: 0,
      tableStep: 0,
      titleStep: 0,
      slicer: o,
      __to__: null,
      maxX: l,
      showSparklineTable: !0,
      segregateStep: 0,
      sliderId: Je,
      fontSizes: {
        xAxis: 18,
        yAxis: 12,
        dataLabels: 20,
        plotLabels: 10
      },
      plotRadii: {
        plot: 3,
        line: 3
      },
      selectedMinimapIndex: null,
      showUserOptionsOnChartHover: !1,
      keepUserOptionState: !0,
      userOptionsVisible: !0
    };
  },
  watch: {
    dataset: {
      handler(i, l) {
        this.maxX = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({
          data: o.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }).length)), this.slicer = {
          start: 0,
          end: this.maxX
        }, this.slicerStep += 1, this.segregateStep += 1;
      },
      deep: !0
    },
    config: {
      handler(i, l) {
        this.FINAL_CONFIG = this.prepareConfig(), this.prepareChart(), this.titleStep += 1, this.tableStep += 1;
      },
      deep: !0
    }
  },
  computed: {
    optimize() {
      return {
        linePlot: this.maxSeries > this.FINAL_CONFIG.line.dot.hideAboveMaxSerieLength
      };
    },
    hasOptionsNoTitle() {
      return this.FINAL_CONFIG.chart.userOptions.show && (!this.FINAL_CONFIG.chart.title.show || !this.FINAL_CONFIG.chart.title.text);
    },
    minimap() {
      if (!this.FINAL_CONFIG.chart.zoom.minimap.show) return [];
      const i = this.datasetWithIds.filter((t) => !this.segregatedSeries.includes(t.id)), l = Math.max(...i.map((t) => t.series.length)), o = [];
      for (let t = 0; t < l; t += 1)
        o.push(i.map((e) => e.series[t] || 0).reduce((e, N) => (e || 0) + (N || 0), 0));
      const d = Math.min(...o);
      return o.map((t) => t + (d < 0 ? Math.abs(d) : 0));
    },
    customPalette() {
      return this.convertCustomPalette(this.FINAL_CONFIG.customPalette);
    },
    backgroundColor() {
      return this.FINAL_CONFIG.chart.backgroundColor;
    },
    slicerColor() {
      return this.FINAL_CONFIG.chart.zoom.color;
    },
    allScales() {
      const i = this.lineSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height,
        autoScaleYLabels: t.autoScaleYLabels
      })), l = this.barSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), o = this.plotSet.map((t) => ({
        name: t.name,
        color: t.color,
        scale: t.individualScale,
        scaleYLabels: t.scaleYLabels,
        // FIX
        zero: t.zeroPosition,
        max: t.individualMax,
        scaleLabel: t.scaleLabel || "",
        id: t.id,
        yOffset: t.yOffset || 0,
        individualHeight: t.individualHeight || this.drawingArea.height
      })), d = [...i, ...l, ...o].flatMap((t) => t).length;
      return [...i, ...l, ...o].flatMap((t, e) => ({
        id: t.id,
        scaleLabel: t.scaleLabel,
        name: t.name,
        color: t.color,
        scale: t.scale,
        yOffset: t.yOffset,
        individualHeight: t.individualHeight,
        x: this.mutableConfig.isStacked ? this.drawingArea.left : this.drawingArea.left / d * (e + 1),
        yLabels: t.scaleYLabels || t.scale.ticks.map((N) => ({
          y: N >= 0 ? t.zero - t.individualHeight * (N / t.max) : t.zero + t.individualHeight * Math.abs(N) / t.max,
          value: N
        }))
      }));
    },
    isDataset() {
      return !!this.dataset && this.dataset.length;
    },
    chartFont() {
      const i = document.getElementById(`vue-ui-xy_${this.uniqueId}`);
      return window.getComputedStyle(i, null).getPropertyValue("font-family");
    },
    FINAL_CONFIG: {
      get: function() {
        return this.prepareConfig();
      },
      set: function(i) {
        return i;
      }
    },
    hasHighlightArea() {
      return Array.isArray(this.FINAL_CONFIG.chart.highlightArea) ? this.FINAL_CONFIG.chart.highlightArea.some((i) => i.show) : this.FINAL_CONFIG.chart.highlightArea && this.FINAL_CONFIG.chart.highlightArea.show;
    },
    highlightAreas() {
      if (Array.isArray(this.FINAL_CONFIG.chart.highlightArea))
        return this.FINAL_CONFIG.chart.highlightArea.map((l) => ({
          ...l,
          span: l.from === l.to ? 1 : l.to < l.from ? 0 : l.to - l.from + 1
        }));
      const i = this.FINAL_CONFIG.chart.highlightArea;
      return [{ ...i, span: i.from === i.to ? 1 : i.to < i.from ? 0 : i.to - i.from + 1 }];
    },
    xPadding() {
      return this.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : this.drawingArea.width / this.maxSeries / 2;
    },
    relativeZero() {
      return [null, void 0].includes(this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin) ? this.niceScale.min >= 0 ? 0 : Math.abs(this.niceScale.min) : -this.niceScale.min;
    },
    absoluteMax() {
      return this.niceScale.max + this.relativeZero;
    },
    datasetWithIds() {
      return this.useSafeValues ? this.dataset.map((i, l) => ({
        ...i,
        series: this.largestTriangleThreeBucketsArray({
          data: i.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        }),
        id: `uniqueId_${l}`
      })) : this.dataset;
    },
    safeDataset() {
      return this.useSafeValues ? this.dataset.map((i, l) => {
        const o = this.largestTriangleThreeBucketsArray({
          data: i.series,
          threshold: this.FINAL_CONFIG.downsample.threshold
        });
        return {
          ...i,
          slotAbsoluteIndex: l,
          series: o.map((d) => this.isSafeValue(d) ? d : null).slice(this.slicer.start, this.slicer.end),
          color: this.convertColorToHex(i.color ? i.color : this.customPalette[l] ? this.customPalette[l] : this.palette[l]),
          id: `uniqueId_${l}`
        };
      }) : this.dataset;
    },
    relativeDataset() {
      return this.safeDataset.map((i, l) => ({
        ...i,
        series: i.series.map((o) => o + this.relativeZero),
        absoluteValues: i.series
      })).filter((i) => !this.segregatedSeries.includes(i.id));
    },
    tableSparklineDataset() {
      return this.relativeDataset.map((i) => {
        const l = i.absoluteValues.map((o) => [void 0, null].includes(o) ? 0 : o);
        return {
          id: i.id,
          name: i.name,
          color: i.color,
          values: this.fillArray(this.maxSeries, l)
        };
      });
    },
    tableSparklineConfig() {
      return {
        responsiveBreakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint,
        roundingValues: this.FINAL_CONFIG.table.rounding,
        showAverage: !1,
        showMedian: !1,
        showTotal: !1,
        fontFamily: this.FINAL_CONFIG.chart.fontFamily,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix,
        colNames: JSON.parse(JSON.stringify(this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values)),
        thead: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        tbody: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        userOptions: {
          show: !1
        }
      };
    },
    absoluteDataset() {
      return this.safeDataset.map((i, l) => ({
        absoluteIndex: l,
        ...i,
        series: i.series.map((o) => o + this.relativeZero),
        absoluteValues: i.series,
        segregate: () => this.segregate(i),
        isSegregated: this.segregatedSeries.includes(i.id)
      }));
    },
    barSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "bar").map((i, l) => {
        this.checkAutoScaleError(i);
        const o = Math.min(...i.absoluteValues.filter((x) => ![null, void 0].includes(x))), d = Math.max(...i.absoluteValues.filter((x) => ![null, void 0].includes(x))), e = {
          ratios: i.absoluteValues.filter((x) => ![null, void 0].includes(x)).map((x) => (x - o) / (d - o)),
          valueMin: o,
          valueMax: d < 0 ? 0 : d
        }, N = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || Math.min(...i.absoluteValues.filter((x) => ![void 0, null].includes(x))) > 0 ? 0 : Math.min(...i.absoluteValues.filter((x) => ![null, void 0].includes(x)))
        }, _ = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, O = 1.0000001, I = this.calculateNiceScaleWithExactExtremes(N.min, N.max === N.min ? N.max * O : N.max, _), b = this.calculateNiceScaleWithExactExtremes(e.valueMin, e.valueMax === e.valueMin ? e.valueMax * O : e.valueMax, _), V = I.min >= 0 ? 0 : Math.abs(I.min), v = 0, z = I.max + V, G = b.max + Math.abs(v), F = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, C = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, T = this.drawingArea.bottom - F - C * V / z, r = this.drawingArea.bottom - F - C * v / G, h = this.absoluteDataset.filter((x) => x.type === "bar").filter((x) => !this.segregatedSeries.includes(x.id)).length, n = i.series.map((x, p) => {
          const y = this.mutableConfig.useIndividualScale ? (i.absoluteValues[p] + V) / z : this.ratioToMax(x), S = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * p : this.drawingArea.left + this.slot.bar * l + this.slot.bar * p * h - this.barSlot / 2 - l * this.barPeriodGap;
          return {
            yOffset: this.checkNaN(F),
            individualHeight: this.checkNaN(C),
            x: this.checkNaN(S),
            y: this.drawingArea.bottom - F - C * y,
            value: i.absoluteValues[p],
            zeroPosition: this.checkNaN(T),
            individualMax: this.checkNaN(z),
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[p] || ""
          };
        }), g = i.absoluteValues.map((x) => b.min >= 0 ? (x - Math.abs(b.min)) / (b.max - Math.abs(b.min)) : (x + Math.abs(b.min)) / (b.max + Math.abs(b.min))), Y = i.series.map((x, p) => {
          const y = this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.drawingArea.left + this.drawingArea.width / this.maxSeries * p : this.drawingArea.left - this.slot.bar / 2 + this.slot.bar * l + this.slot.bar * p * this.absoluteDataset.filter((S) => S.type === "bar").filter((S) => !this.segregatedSeries.includes(S.id)).length;
          return {
            yOffset: this.checkNaN(F),
            individualHeight: this.checkNaN(C),
            x: this.checkNaN(y),
            y: this.checkNaN(this.drawingArea.bottom - this.checkNaN(F) - (this.checkNaN(C) * g[p] || 0)),
            value: i.absoluteValues[p],
            zeroPosition: this.checkNaN(T),
            individualMax: this.checkNaN(z),
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[p] || ""
          };
        }), A = I.ticks.map((x) => ({
          y: x >= 0 ? T - C * (x / z) : T + C * Math.abs(x) / z,
          value: x,
          prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: i
        })), M = b.ticks.map((x) => {
          const p = (x - b.min) / (b.max - b.min);
          return {
            y: x >= 0 ? r - C * p : r + C * p,
            value: x,
            prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: i
          };
        });
        return {
          ...i,
          yOffset: F,
          autoScaleYLabels: M,
          individualHeight: C,
          scaleYLabels: i.autoScaling ? M : A,
          individualScale: i.autoScaling ? b : I,
          individualMax: i.autoScaling ? G : z,
          zeroPosition: i.autoScaling ? r : T,
          plots: i.autoScaling ? Y : n
        };
      });
    },
    activeSeriesLength() {
      return this.absoluteDataset.length;
    },
    activeSeriesWithStackRatios() {
      return this.assignStackRatios(this.absoluteDataset.filter((i) => !this.segregatedSeries.includes(i.id)));
    },
    lineSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "line").map((i) => {
        this.checkAutoScaleError(i);
        const l = Math.min(...i.absoluteValues.filter((y) => ![void 0, null].includes(y))), o = Math.max(...i.absoluteValues.filter((y) => ![void 0, null].includes(y))) || 1, t = {
          ratios: i.absoluteValues.filter((y) => ![null, void 0].includes(y)).map((y) => (y - l) / (o - l)),
          valueMin: l,
          valueMax: o
        }, e = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || (Math.min(...i.absoluteValues) > 0 ? 0 : Math.min(...i.absoluteValues))
        }, N = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, _ = 1.0000001, O = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * _ : e.max, N), I = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * _ : t.valueMax, N), b = O.min >= 0 ? 0 : Math.abs(O.min), V = 0, v = O.max + Math.abs(b), z = I.max + Math.abs(V), G = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, F = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - G - F * b / v, T = this.drawingArea.bottom - G - F * V / z, r = i.series.map((y, S) => {
          const Q = this.mutableConfig.useIndividualScale ? (i.absoluteValues[S] + Math.abs(b)) / v : this.ratioToMax(y);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * S),
            y: this.checkNaN(this.drawingArea.bottom - G - F * Q),
            value: i.absoluteValues[S],
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[S] || ""
          };
        }), h = i.absoluteValues.map((y) => I.min >= 0 ? (y - Math.abs(I.min)) / (I.max - Math.abs(I.min)) : (y + Math.abs(I.min)) / (I.max + Math.abs(I.min))), n = i.series.map((y, S) => [void 0, null].includes(i.absoluteValues[S]) ? {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * S),
          y: C,
          value: i.absoluteValues[S],
          comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[S] || ""
        } : {
          x: this.checkNaN(this.drawingArea.left + this.slot.line / 2 + this.slot.line * S),
          y: this.checkNaN(this.drawingArea.bottom - G - (F * h[S] || 0)),
          value: i.absoluteValues[S],
          comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[S] || ""
        }), g = this.createSmoothPath(r), Y = this.createSmoothPath(n), A = this.createStraightPath(r), M = this.createStraightPath(n), x = O.ticks.map((y) => ({
          y: y >= 0 ? C - F * (y / v) : C + F * Math.abs(y) / v,
          value: y,
          prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: i
        })), p = I.ticks.map((y) => {
          const S = (y - I.min) / (I.max - I.min);
          return {
            y: y >= 0 ? T - F * S : T + F * S,
            value: y,
            prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: i
          };
        });
        return {
          ...i,
          yOffset: G,
          autoScaleYLabels: p,
          individualHeight: F,
          scaleYLabels: i.autoScaling ? p : x,
          individualScale: i.autoScaling ? I : O,
          individualMax: i.autoScaling ? z : v,
          zeroPosition: i.autoScaling ? T : C,
          curve: i.autoScaling ? Y : g,
          plots: i.autoScaling ? n : r,
          area: i.useArea ? this.mutableConfig.useIndividualScale ? this.createIndividualArea(i.autoScaling ? n : r, i.autoScaling ? T : C) : this.createArea(r) : "",
          straight: i.autoScaling ? M : A
        };
      });
    },
    plotSet() {
      return this.activeSeriesWithStackRatios.filter((i) => i.type === "plot").map((i) => {
        this.checkAutoScaleError(i);
        const l = Math.min(...i.absoluteValues.filter((A) => ![null, void 0].includes(A))), o = Math.max(...i.absoluteValues.filter((A) => ![null, void 0].includes(A))) || 1, t = {
          ratios: i.absoluteValues.filter((A) => ![null, void 0].includes(A)).map((A) => (A - l) / (o - l)),
          valueMin: l,
          valueMax: o
        }, e = {
          max: i.scaleMax || Math.max(...i.absoluteValues) || 1,
          min: i.scaleMin || Math.min(...i.absoluteValues) > 0 ? 0 : Math.min(...i.absoluteValues)
        }, N = i.scaleSteps || this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps, _ = 1.0000001, O = this.calculateNiceScaleWithExactExtremes(e.min, e.max === e.min ? e.max * _ : e.max, N), I = this.calculateNiceScaleWithExactExtremes(t.valueMin, t.valueMax === t.valueMin ? t.valueMax * _ : t.valueMax, N), b = O.min >= 0 ? 0 : Math.abs(O.min), V = 0, v = O.max + b, z = I.max + Math.abs(V), G = this.mutableConfig.isStacked ? this.drawingArea.height * (1 - i.cumulatedStackRatio) : 0, F = this.mutableConfig.isStacked ? this.drawingArea.height * i.stackRatio - this.FINAL_CONFIG.chart.grid.labels.yAxis.gap : this.drawingArea.height, C = this.drawingArea.bottom - G - F * b / v, T = this.drawingArea.bottom - G - F * V / z, r = i.series.map((A, M) => {
          const x = this.mutableConfig.useIndividualScale ? (i.absoluteValues[M] + Math.abs(b)) / v : this.ratioToMax(A);
          return {
            x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * M),
            y: this.checkNaN(this.drawingArea.bottom - G - F * x),
            value: i.absoluteValues[M],
            comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[M] || ""
          };
        }), h = i.absoluteValues.map((A) => I.min >= 0 ? (A - Math.abs(I.min)) / (I.max - Math.abs(I.min)) : (A + Math.abs(I.min)) / (I.max + Math.abs(I.min))), n = i.series.map((A, M) => ({
          x: this.checkNaN(this.drawingArea.left + this.slot.plot / 2 + this.slot.plot * M),
          y: this.checkNaN(this.drawingArea.bottom - G - (F * h[M] || 0)),
          value: i.absoluteValues[M],
          comment: i.comments && i.comments.slice(this.slicer.start, this.slicer.end)[M] || ""
        })), g = O.ticks.map((A) => ({
          y: A >= 0 ? C - F * (A / v) : C + F * Math.abs(A) / v,
          value: A,
          prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
          suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
          datapoint: i
        })), Y = I.ticks.map((A) => {
          const M = (A - I.min) / (I.max - I.min);
          return {
            y: A >= 0 ? T - F * M : T + F * M,
            value: A,
            prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
            suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix,
            datapoint: i
          };
        });
        return {
          ...i,
          yOffset: G,
          autoScaleYLabels: Y,
          individualHeight: F,
          scaleYLabels: i.autoScaling ? Y : g,
          individualScale: i.autoScaling ? I : O,
          individualMax: i.autoScaling ? z : v,
          zeroPosition: i.autoScaling ? T : C,
          plots: i.autoScaling ? n : r
        };
      });
    },
    drawingArea() {
      const i = this.mutableConfig.useIndividualScale && this.FINAL_CONFIG.chart.grid.labels.show ? this.absoluteDataset.filter((l) => !this.segregatedSeries.includes(l.id)).length * (this.mutableConfig.isStacked ? 0 : this.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth) : 0;
      return {
        top: this.FINAL_CONFIG.chart.padding.top,
        right: this.width - this.FINAL_CONFIG.chart.padding.right,
        bottom: this.height - this.FINAL_CONFIG.chart.padding.bottom,
        left: this.FINAL_CONFIG.chart.padding.left + i,
        height: this.height - (this.FINAL_CONFIG.chart.padding.top + this.FINAL_CONFIG.chart.padding.bottom),
        width: this.width - (this.FINAL_CONFIG.chart.padding.right + this.FINAL_CONFIG.chart.padding.left + i)
      };
    },
    max() {
      return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax ? this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMax : Math.max(...this.safeDataset.filter((i) => !this.segregatedSeries.includes(i.id)).map((i) => Math.max(...i.series)));
    },
    min() {
      if (this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin !== null)
        return this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin;
      const i = Math.min(...this.safeDataset.filter((l) => !this.segregatedSeries.includes(l.id)).map((l) => Math.min(...l.series)));
      return i > 0 ? 0 : i;
    },
    niceScale() {
      return this.calculateNiceScaleWithExactExtremes(this.min, this.max < 0 ? 0 : this.max, this.FINAL_CONFIG.chart.grid.labels.yAxis.commonScaleSteps);
    },
    maxSeries() {
      return this.slicer.end - this.slicer.start;
    },
    timeLabels() {
      const i = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({ data: o.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length)), l = [];
      for (let o = 0; o < i; o += 1)
        l.push({
          text: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[o] || String(o),
          absoluteIndex: o
        });
      return l.slice(this.slicer.start, this.slicer.end);
    },
    slot() {
      return {
        bar: this.drawingArea.width / this.maxSeries / this.safeDataset.filter((i) => i.type === "bar").filter((i) => !this.segregatedSeries.includes(i.id)).length,
        plot: this.drawingArea.width / this.maxSeries,
        line: this.drawingArea.width / this.maxSeries
      };
    },
    barSlot() {
      const i = this.safeDataset.filter((l) => l.type === "bar").filter((l) => !this.segregatedSeries.includes(l.id)).length;
      return this.drawingArea.width / this.maxSeries / i - this.barPeriodGap * i;
    },
    barPeriodGap() {
      return this.slot.line * this.FINAL_CONFIG.bar.periodGap;
    },
    maxSlot() {
      return Math.max(...Object.values(this.slot).filter((i) => i !== 1 / 0));
    },
    table() {
      if (this.safeDataset.length === 0) return { head: [], body: [], config: {}, columnNames: [] };
      const i = this.relativeDataset.map((o) => ({
        label: o.name,
        color: o.color,
        type: o.type
      })), l = [];
      return this.timeLabels.forEach((o, d) => {
        const t = [o.text];
        this.relativeDataset.forEach((e) => {
          t.push(this.canShowValue(e.absoluteValues[d]) ? Number(e.absoluteValues[d].toFixed(this.FINAL_CONFIG.table.rounding)) : "");
        }), l.push(t);
      }), { head: i, body: l };
    },
    dataTable() {
      const i = this.FINAL_CONFIG.table.showSum;
      let l = [""].concat(this.relativeDataset.map((e) => e.name));
      i && (l = l.concat(' <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" fill="none" stroke-linecap="round" stroke-linejoin="round"><path stroke="none" d="M0 0h24v24H0z" fill="none"/><path d="M18 16v2a1 1 0 0 1 -1 1h-11l6 -7l-6 -7h11a1 1 0 0 1 1 1v2" /></svg>'));
      let o = [];
      for (let e = 0; e < this.maxSeries; e += 1) {
        const N = this.relativeDataset.map((_) => _.absoluteValues[e] ?? 0).reduce((_, O) => _ + O, 0);
        o.push(
          [
            this.timeLabels[e].text ?? "-"
          ].concat(this.relativeDataset.map(
            (_) => this.applyDataLabel(
              _.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : _.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
              _.absoluteValues[e] ?? 0,
              this.dataLabel({
                p: _.prefix || this.FINAL_CONFIG.chart.labels.prefix,
                v: _.absoluteValues[e] ?? 0,
                s: _.suffix || this.FINAL_CONFIG.chart.labels.suffix,
                r: this.FINAL_CONFIG.table.rounding
              })
            )
          )).concat(i ? (N ?? 0).toFixed(this.FINAL_CONFIG.table.rounding) : [])
        );
      }
      const d = {
        th: {
          backgroundColor: this.FINAL_CONFIG.table.th.backgroundColor,
          color: this.FINAL_CONFIG.table.th.color,
          outline: this.FINAL_CONFIG.table.th.outline
        },
        td: {
          backgroundColor: this.FINAL_CONFIG.table.td.backgroundColor,
          color: this.FINAL_CONFIG.table.td.color,
          outline: this.FINAL_CONFIG.table.td.outline
        },
        breakpoint: this.FINAL_CONFIG.table.responsiveBreakpoint
      }, t = [this.FINAL_CONFIG.table.columnNames.period].concat(this.relativeDataset.map((e) => e.name)).concat(this.FINAL_CONFIG.table.columnNames.total);
      return { head: l, body: o, config: d, colNames: t };
    },
    dataTooltipSlot() {
      return {
        datapoint: this.selectedSeries,
        seriesIndex: this.selectedSerieIndex,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      };
    },
    selectedSeries() {
      return this.relativeDataset.map((i) => ({
        slotAbsoluteIndex: i.slotAbsoluteIndex,
        shape: i.shape || null,
        name: i.name,
        color: i.color,
        type: i.type,
        value: i.absoluteValues.find((l, o) => o === this.selectedSerieIndex),
        comments: i.comments || [],
        prefix: i.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: i.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    tooltipContent() {
      let i = "", l = this.selectedSeries.map((t) => t.value).filter((t) => this.isSafeValue(t) && t !== null).reduce((t, e) => Math.abs(t) + Math.abs(e), 0);
      const o = this.timeLabels[this.selectedSerieIndex], d = this.FINAL_CONFIG.chart.tooltip.customFormat;
      return this.isFunction(d) && this.functionReturnsString(() => d({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      })) ? d({
        seriesIndex: this.selectedSerieIndex,
        datapoint: this.selectedSeries,
        series: this.absoluteDataset,
        bars: this.barSet,
        lines: this.lineSet,
        plots: this.plotSet,
        config: this.FINAL_CONFIG
      }) : (o && o.text && this.FINAL_CONFIG.chart.tooltip.showTimeLabel && (i += `<div style="padding-bottom: 6px; margin-bottom: 4px; border-bottom: 1px solid ${this.FINAL_CONFIG.chart.tooltip.borderColor}; width:100%">${o.text}</div>`), this.selectedSeries.forEach((t) => {
        if (this.isSafeValue(t.value)) {
          let e = "", N = "";
          switch (this.icons[t.type]) {
            case "bar":
              e = `<svg viewBox="0 0 40 40" height="14" width="14">${this.$slots.pattern ? `<rect x="0" y="0" rx="1" stroke="none" height="40" width="40" fill="${t.color}" />` : ""}<rect x="0" y="0" rx="1" stroke="none" height="40" width="40" fill="${this.$slots.pattern ? `url(#pattern_${this.uniqueId}_${t.slotAbsoluteIndex}` : t.color}" /></svg>`;
              break;
            case "line":
              !t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape) ? N = `<circle cx="10" cy="8" r="4" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" fill="${t.color}" />` : t.shape === "triangle" ? N = `<path d="${H({ plot: { x: 10, y: 8 }, radius: 4, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "square" ? N = `<path d="${H({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "diamond" ? N = `<path d="${H({ plot: { x: 10, y: 8 }, radius: 4, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "pentagon" ? N = `<path d="${H({ plot: { x: 10, y: 8 }, radius: 4, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "hexagon" ? N = `<path d="${H({ plot: { x: 10, y: 8 }, radius: 4, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" />` : t.shape === "star" && (N = `<polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" fill="${t.color}" points="${X({ plot: { x: 10, y: 8 }, radius: 4 })}" />`), e = `<svg viewBox="0 0 20 12" height="14" width="20"><rect rx="1.5" x="0" y="6.5" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="0.5" height="3" width="20" fill="${t.color}" />${N}</svg>`;
              break;
            case "plot":
              if (!t.shape || !["star", "triangle", "square", "diamond", "pentagon", "hexagon"].includes(t.shape)) {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><circle cx="6" cy="6" r="6" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" /></svg>`;
                break;
              }
              if (t.shape === "star") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><polygon stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" fill="${t.color}" points="${X({ plot: { x: 6, y: 6 }, radius: 5 })}" /></svg>`;
                break;
              }
              if (t.shape === "triangle") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${H({ plot: { x: 6, y: 6 }, radius: 6, sides: 3, rotation: 0.52 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "square") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${H({ plot: { x: 6, y: 6 }, radius: 6, sides: 4, rotation: 0.8 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "diamond") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${H({ plot: { x: 6, y: 6 }, radius: 5, sides: 4, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "pentagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${H({ plot: { x: 6, y: 6 }, radius: 5, sides: 5, rotation: 0.95 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
              if (t.shape === "hexagon") {
                e = `<svg viewBox="0 0 12 12" height="14" width="14"><path d="${H({ plot: { x: 6, y: 6 }, radius: 5, sides: 6, rotation: 0 }).path}" fill="${t.color}" stroke="${this.FINAL_CONFIG.chart.tooltip.backgroundColor}" stroke-width="1" /></svg>`;
                break;
              }
          }
          i += `<div style="display:flex;flex-direction:row; align-items:center;gap:3px;"><div style="width:20px">${e}</div> ${t.name}: <b>${this.FINAL_CONFIG.chart.tooltip.showValue ? this.applyDataLabel(
            t.type === "line" ? this.FINAL_CONFIG.line.labels.formatter : t.type === "bar" ? this.FINAL_CONFIG.bar.labels.formatter : this.FINAL_CONFIG.plot.labels.formatter,
            t.value,
            this.dataLabel({
              p: t.prefix,
              v: t.value,
              s: t.suffix,
              r: this.FINAL_CONFIG.chart.tooltip.roundingValue
            }),
            { datapoint: t }
          ) : ""}</b> ${this.FINAL_CONFIG.chart.tooltip.showPercentage ? `(${U({
            v: this.checkNaN(Math.abs(t.value) / l * 100),
            s: "%",
            r: this.FINAL_CONFIG.chart.tooltip.roundingPercentage
          })})` : ""}</div>`, this.FINAL_CONFIG.chart.comments.showInTooltip && t.comments.length && t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex] && (i += `<div class="vue-data-ui-tooltip-comment" style="background:${t.color}20; padding: 6px; margin-bottom: 6px; border-left: 1px solid ${t.color}">${t.comments.slice(this.slicer.start, this.slicer.end)[this.selectedSerieIndex]}</div>`);
        }
      }), `<div style="border-radius:4px;padding:12px;font-variant-numeric: tabular-nums;color:${this.FINAL_CONFIG.chart.tooltip.color}">${i}</div>`);
    },
    svg() {
      return {
        height: this.height,
        width: this.width
      };
    },
    yLabels() {
      return this.niceScale.ticks.map((i) => ({
        y: i >= 0 ? this.zero - this.drawingArea.height * this.ratioToMax(i) : this.zero + this.drawingArea.height * this.ratioToMax(Math.abs(i)),
        value: i,
        prefix: this.FINAL_CONFIG.chart.labels.prefix,
        suffix: this.FINAL_CONFIG.chart.labels.suffix
      }));
    },
    zero() {
      return this.drawingArea.bottom - this.drawingArea.height * this.ratioToMax(this.relativeZero);
    }
  },
  mounted() {
    this.prepareChart(), this.setupSlicer(), document.addEventListener("mousemove", (i) => {
      this.clientPosition = {
        x: i.clientX,
        y: i.clientY
      };
    });
  },
  methods: {
    abbreviate: te,
    adaptColorToBackground: ie,
    applyDataLabel: re,
    assignStackRatios: ae,
    calcLinearProgression: le,
    calculateNiceScaleWithExactExtremes: se,
    checkNaN: ne,
    closestDecimal: he,
    convertColorToHex: oe,
    convertConfigColors: ce,
    convertCustomPalette: de,
    createCsvContent: ue,
    createSmoothPath: ge,
    createStraightPath: fe,
    createTSpans: Ie,
    dataLabel: U,
    downloadCsv: me,
    error: Ne,
    forceValidValue: xe,
    functionReturnsString: be,
    hasDeepProperty: Fe,
    isFunction: _e,
    isSafeValue: Ae,
    largestTriangleThreeBucketsArray: ye,
    objectIsEmpty: Le,
    setOpacity: Ce,
    shiftHue: Se,
    translateSize: ke,
    treeShake: we,
    useMouse: Me,
    useNestedProp: Z,
    setUserOptionsVisibility(i = !1) {
      this.showUserOptionsOnChartHover && (this.userOptionsVisible = i);
    },
    toggleAnnotator() {
      this.isAnnotator = !this.isAnnotator;
    },
    selectTimeLabel(i, l) {
      const o = this.relativeDataset.map((d) => ({
        shape: d.shape || null,
        name: d.name,
        color: d.color,
        type: d.type,
        value: d.absoluteValues.find((t, e) => e === l),
        comments: d.comments || [],
        prefix: d.prefix || this.FINAL_CONFIG.chart.labels.prefix,
        suffix: d.suffix || this.FINAL_CONFIG.chart.labels.suffix
      }));
      this.$emit("selectTimeLabel", {
        datapoint: o,
        absoluteIndex: i.absoluteIndex,
        label: i.text
      });
    },
    getHighlightAreaPosition(i) {
      const l = this.drawingArea.left + this.drawingArea.width / this.maxSeries * (i.from - this.slicer.start), o = this.drawingArea.width / (this.slicer.end - this.slicer.start) * i.span < 0 ? 1e-5 : this.drawingArea.width / (this.slicer.end - this.slicer.start) * i.span;
      return {
        x: l < this.drawingArea.left ? this.drawingArea.left : l,
        width: o
      };
    },
    prepareConfig() {
      const i = Oe().vue_ui_xy;
      if (!Object.keys(this.config || {}).length)
        return i;
      const l = this.useNestedProp({
        userConfig: this.config,
        defaultConfig: i
      });
      return this.config && this.hasDeepProperty(this.config, "chart.highlightArea") && (Array.isArray(this.config.chart.highlightArea) ? l.chart.highlightArea = this.config.chart.highlightArea : l.chart.highlightArea = [this.config.chart.highlightArea]), this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMin") ? l.chart.grid.labels.yAxis.scaleMin = this.config.chart.grid.labels.yAxis.scaleMin : l.chart.grid.labels.yAxis.scaleMin = null, this.config && this.hasDeepProperty(this.config, "chart.grid.labels.yAxis.scaleMax") ? l.chart.grid.labels.yAxis.scaleMax = this.config.chart.grid.labels.yAxis.scaleMax : l.chart.grid.labels.yAxis.scaleMax = null, this.config && this.hasDeepProperty(this.config, "chart.zoom.startIndex") ? l.chart.zoom.startIndex = this.config.chart.zoom.startIndex : l.chart.zoom.startIndex = null, this.config && this.hasDeepProperty(this.config, "chart.zoom.endIndex") ? l.chart.zoom.endIndex = this.config.chart.zoom.endIndex : l.chart.zoom.endIndex = null, l.theme ? {
        ...Z({
          userConfig: this.themes.vue_ui_xy[l.theme] || this.config,
          defaultConfig: l
        }),
        customPalette: this.themePalettes[l.theme] || this.palette
      } : l;
    },
    prepareChart() {
      if (this.objectIsEmpty(this.dataset) ? this.error({
        componentName: "VueUiXy",
        type: "dataset"
      }) : this.dataset.forEach((i, l) => {
        [null, void 0].includes(i.name) && this.error({
          componentName: "VueUiXy",
          type: "datasetSerieAttribute",
          property: "name (string)",
          index: l
        });
      }), this.FINAL_CONFIG.showWarnings && this.dataset.forEach((i) => {
        i.series.forEach((l, o) => {
          this.isSafeValue(l) || console.warn(`VueUiXy has detected an unsafe value in your dataset:
-----> The serie '${i.name}' contains the value '${l}' at index ${o}.
'${l}' was converted to null to allow the chart to display.`);
        });
      }), this.showUserOptionsOnChartHover = this.FINAL_CONFIG.chart.userOptions.showOnChartHover, this.keepUserOptionState = this.FINAL_CONFIG.chart.userOptions.keepStateOnChartLeave, this.userOptionsVisible = !this.FINAL_CONFIG.chart.userOptions.showOnChartHover, this.mutableConfig = {
        dataLabels: {
          show: !0
        },
        showTooltip: this.FINAL_CONFIG.chart.tooltip.show === !0,
        showTable: this.FINAL_CONFIG.showTable === !0,
        isStacked: this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked,
        useIndividualScale: this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale
      }, this.FINAL_CONFIG.responsive) {
        const l = this.$refs.chart.parentNode, { height: o, width: d } = l.getBoundingClientRect();
        let t = null, e = 0;
        this.FINAL_CONFIG.chart.title.show && (t = this.$refs.chartTitle, e = t.getBoundingClientRect().height);
        let N = null, _ = 0;
        this.FINAL_CONFIG.chart.zoom.show && this.maxX > 6 && this.isDataset && (N = this.$refs.chartSlicer.$el, _ = N.getBoundingClientRect().height);
        let O = null, I = 0;
        this.FINAL_CONFIG.chart.legend.show && (O = this.$refs.chartLegend, I = O.getBoundingClientRect().height);
        let b = 0;
        this.$refs.source && (b = this.$refs.source.getBoundingClientRect().height);
        let V = 0;
        this.$refs.noTitle && (V = this.$refs.noTitle.getBoundingClientRect().height), this.height = o - e - I - _ - b - V, this.width = d, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes(), new ResizeObserver((z) => {
          for (const G of z)
            this.$refs.chartTitle && (e = this.$refs.chartTitle.getBoundingClientRect().height), this.$refs.chartSlicer && this.$refs.chartSlicer.$el && (_ = this.$refs.chartSlicer.$el.getBoundingClientRect().height), this.$refs.chartLegend && (I = this.$refs.chartLegend.getBoundingClientRect().height), this.$refs.source && (b = this.$refs.source.getBoundingClientRect().height), this.height = G.contentBoxSize[0].blockSize - e - I - _ - b - 24, this.width = G.contentBoxSize[0].inlineSize, this.viewBox = `0 0 ${this.width < 0 ? 10 : this.width} ${this.height < 0 ? 10 : this.height}`, this.convertSizes();
        }).observe(l);
      } else
        this.height = this.FINAL_CONFIG.chart.height, this.width = this.FINAL_CONFIG.chart.width, this.viewBox = `0 0 ${this.width} ${this.height}`, this.fontSizes.dataLabels = this.FINAL_CONFIG.chart.grid.labels.fontSize, this.fontSizes.yAxis = this.FINAL_CONFIG.chart.grid.labels.axis.fontSize, this.fontSizes.xAxis = this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize, this.fontSizes.plotLabels = this.FINAL_CONFIG.chart.labels.fontSize, this.plotRadii.plot = this.FINAL_CONFIG.plot.radius, this.plotRadii.line = this.FINAL_CONFIG.line.radius;
    },
    selectMinimapIndex(i) {
      this.selectedMinimapIndex = i;
    },
    convertSizes() {
      this.fontSizes.dataLabels = this.translateSize({
        relator: this.height,
        adjuster: 400,
        source: this.FINAL_CONFIG.chart.grid.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.yAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.axis.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.xAxis = this.translateSize({
        relator: this.width,
        adjuster: 1e3,
        source: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.fontSizes.plotLabels = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.chart.labels.fontSize,
        threshold: 10,
        fallback: 10
      }), this.plotRadii.plot = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.plot.radius,
        threshold: 1,
        fallback: 1
      }), this.plotRadii.line = this.translateSize({
        relator: this.width,
        adjuster: 800,
        source: this.FINAL_CONFIG.line.radius,
        threshold: 1,
        fallback: 1
      });
    },
    toggleStack() {
      this.mutableConfig.isStacked = !this.mutableConfig.isStacked, this.mutableConfig.isStacked ? this.mutableConfig.useIndividualScale = !0 : this.mutableConfig.useIndividualScale = this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale;
    },
    toggleTable() {
      this.mutableConfig.showTable = !this.mutableConfig.showTable;
    },
    toggleLabels() {
      this.mutableConfig.dataLabels.show = !this.mutableConfig.dataLabels.show;
    },
    toggleTooltip() {
      this.mutableConfig.showTooltip = !this.mutableConfig.showTooltip;
    },
    checkAutoScaleError(i) {
      i.autoScaling && (this.FINAL_CONFIG.chart.grid.labels.yAxis.useIndividualScale || console.warn(`VueUiXy (datapoint: ${i.name}) : autoScaling only works when config.chart.grid.labels.yAxis.useIndividualScale is set to true`), this.FINAL_CONFIG.chart.grid.labels.yAxis.stacked || console.warn(`VueUiXy (datapoint: ${i.name}) : autoScaling only works when config.chart.grid.labels.yAxis.stacked is set to true`));
    },
    createArea(i) {
      if (!i[0]) return [-10, -10, "", -10, -10];
      const l = { x: i[0].x, y: this.zero }, o = { x: i.at(-1).x, y: this.zero }, d = [];
      return i.forEach((t) => {
        d.push(`${t.x},${t.y} `);
      }), [l.x, l.y, ...d, o.x, o.y].toString();
    },
    createIndividualArea(i, l) {
      if (!i[0]) return [-10, -10, "", -10, -10];
      const o = { x: i[0] ? i[0].x : Math.min(...i.filter((e) => !!e).map((e) => e.x)), y: l }, d = { x: i.at(-1) ? i.at(-1).x : Math.min(...i.filter((e) => !!e).map((e) => e.x)), y: l }, t = [];
      return i.filter((e) => !!e).forEach((e) => {
        t.push(`${e.x},${e.y} `);
      }), [o.x, o.y, ...t, d.x, d.y].toString();
    },
    createStar: X,
    createPolygonPath: H,
    fillArray(i, l) {
      let o = Array(i).fill(0);
      for (let d = 0; d < l.length && d < i; d += 1)
        o[d] = l[d];
      return o;
    },
    async setupSlicer() {
      (this.FINAL_CONFIG.chart.zoom.startIndex !== null || this.FINAL_CONFIG.chart.zoom.endIndex !== null) && this.$refs.chartSlicer ? (this.FINAL_CONFIG.chart.zoom.startIndex !== null && (await this.$nextTick(), await this.$nextTick(), this.$refs.chartSlicer.setStartValue(this.FINAL_CONFIG.chart.zoom.startIndex)), this.FINAL_CONFIG.chart.zoom.endIndex !== null && (await this.$nextTick(), await this.$nextTick(), this.$refs.chartSlicer.setEndValue(this.validSlicerEnd(this.FINAL_CONFIG.chart.zoom.endIndex + 1)))) : (this.slicer = {
        start: 0,
        end: Math.max(...this.dataset.map((i) => this.largestTriangleThreeBucketsArray({ data: i.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length))
      }, this.slicerStep += 1);
    },
    refreshSlicer() {
      this.setupSlicer();
    },
    validSlicerEnd(i) {
      const l = Math.max(...this.dataset.map((o) => this.largestTriangleThreeBucketsArray({ data: o.series, threshold: this.FINAL_CONFIG.downsample.threshold }).length));
      return i > l ? l : i < 0 || this.FINAL_CONFIG.chart.zoom.startIndex !== null && i < this.FINAL_CONFIG.chart.zoom.startIndex ? this.FINAL_CONFIG.chart.zoom.startIndex !== null ? this.FINAL_CONFIG.chart.zoom.startIndex + 1 : 1 : i;
    },
    calcRectHeight(i) {
      const l = ![null, void 0].includes(this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin) && this.FINAL_CONFIG.chart.grid.labels.yAxis.scaleMin > 0 && this.min >= 0 ? this.drawingArea.bottom : this.zero;
      return i.value >= 0 ? this.checkNaN(l - i.y <= 0 ? 1e-5 : l - i.y) : this.checkNaN(i.y - this.zero <= 0 ? 1e-5 : i.y - this.zero);
    },
    calcIndividualHeight(i) {
      return i.value >= 0 ? this.checkNaN(i.zeroPosition - i.y <= 0 ? 1e-5 : i.zeroPosition - i.y) : this.checkNaN(i.y - i.zeroPosition <= 0 ? 1e-5 : i.zeroPosition - i.y);
    },
    calcRectWidth() {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? this.slot.line - this.drawingArea.width / this.maxSeries * 0.1 : this.slot.bar;
    },
    calcRectX(i) {
      return this.mutableConfig.useIndividualScale && this.mutableConfig.isStacked ? i.x + this.drawingArea.width / this.maxSeries * 0.05 : i.x + this.slot.bar / 2;
    },
    calcRectY(i) {
      return i.value >= 0 ? i.y : this.zero;
    },
    calcIndividualRectY(i) {
      return i.value >= 0 ? i.y : [null, void 0, NaN, 1 / 0, -1 / 0].includes(i.zeroPosition) ? 0 : i.zeroPosition;
    },
    canShowValue(i) {
      return ![null, void 0, NaN, 1 / 0, -1 / 0].includes(i);
    },
    findClosestValue(i, l) {
      let o = l[0], d = Math.abs(i - l[0]);
      for (let t = 1; t < l.length; t += 1) {
        const e = Math.abs(i - l[t]);
        e < d && l[t] < i && (o = l[t], d = e);
      }
      return o;
    },
    ratioToMax(i) {
      return i / (this.canShowValue(this.absoluteMax) ? this.absoluteMax : 1);
    },
    selectX(i) {
      this.$emit(
        "selectX",
        {
          dataset: this.relativeDataset.map((l) => ({
            name: l.name,
            value: [null, void 0, NaN].includes(l.absoluteValues[i]) ? null : l.absoluteValues[i],
            color: l.color,
            type: l.type
          })),
          index: i,
          indexLabel: this.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[i]
        }
      );
    },
    getData() {
      return this.absoluteDataset.map((i) => ({
        values: i.absoluteValues,
        color: i.color,
        name: i.name,
        type: i.type
      }));
    },
    segregate(i) {
      if (this.segregatedSeries.includes(i.id))
        this.segregatedSeries = this.segregatedSeries.filter((l) => l !== i.id);
      else {
        if (this.segregatedSeries.length + 1 === this.safeDataset.length) return;
        this.segregatedSeries.push(i.id);
      }
      this.$emit("selectLegend", this.relativeDataset.map((l) => ({
        name: l.name,
        values: l.absoluteValues,
        color: l.color,
        type: l.type
      }))), this.segregateStep += 1;
    },
    toggleTooltipVisibility(i, l = null) {
      this.isTooltip = i, i ? this.selectedSerieIndex = l : this.selectedSerieIndex = null;
    },
    toggleFullscreen(i) {
      this.isFullscreen = i, this.step += 1;
    },
    showSpinnerPdf() {
      this.isPrinting = !0;
    },
    async generatePdf() {
      this.showSpinnerPdf(), clearTimeout(this.__to__), this.isPrinting = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: i } = await import("./pdf-B7oVat64.js");
          await i({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy"
          });
        } catch (i) {
          console.error("Error generating PDF:", i);
        } finally {
          this.isPrinting = !1;
        }
      }, 100);
    },
    generateCsv() {
      const i = [[this.FINAL_CONFIG.chart.title.text], [this.FINAL_CONFIG.chart.title.subtitle.text], [""]], l = ["", ...this.table.head.map((e) => e.label)], o = this.table.body, d = i.concat([l]).concat(o), t = this.createCsvContent(d);
      this.downloadCsv({ csvContent: t, title: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy" });
    },
    showSpinnerImage() {
      this.isImaging = !0;
    },
    async generateImage() {
      this.showSpinnerImage(), clearTimeout(this.__to__), this.isImaging = !0, this.__to__ = setTimeout(async () => {
        try {
          const { default: i } = await import("./img-DGzWcJ4Y.js");
          await i({
            domElement: document.getElementById(`vue-ui-xy_${this.uniqueId}`),
            fileName: this.FINAL_CONFIG.chart.title.text || "vue-ui-xy",
            format: "png"
          });
        } catch (i) {
          console.error("Error generating image:", i);
        } finally {
          this.isImaging = !1;
        }
      }, 100);
    }
  }
}, Ke = ["id"], je = {
  key: 1,
  ref: "noTitle",
  class: "vue-data-ui-no-title-space",
  style: "height:36px; width: 100%; background:transparent"
}, $e = ["viewBox"], et = ["x", "y", "width", "height"], tt = { key: 1 }, it = { class: "vue-ui-xy-grid" }, rt = ["stroke", "x1", "x2", "y1", "y2"], at = ["stroke", "x1", "x2", "y1", "y2"], lt = { key: 1 }, st = ["x1", "x2", "y1", "y2", "stroke"], nt = ["x1", "x2", "y1", "y2", "stroke"], ht = ["x1", "x2", "y1", "y2", "stroke"], ot = { key: 3 }, ct = ["x1", "x2", "y1", "y2", "stroke"], dt = ["id"], ut = ["stop-color"], gt = ["stop-color"], ft = ["stop-color"], It = ["id"], mt = ["stop-color"], Nt = ["stop-color"], xt = ["stop-color"], bt = ["id"], Ft = ["stop-color"], _t = ["stop-color"], At = ["id"], yt = ["stop-color"], Lt = ["stop-color"], Ct = ["id"], St = ["stop-color"], kt = ["stop-color"], wt = ["x", "y", "height", "width", "fill"], Ot = ["x", "y", "width"], Gt = ["x", "y", "height", "width", "fill"], vt = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], zt = ["x", "y", "height", "width", "rx", "fill", "stroke", "stroke-width"], Mt = ["width", "x", "y"], pt = { key: 0 }, Tt = ["id"], Pt = ["fill"], Vt = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], Rt = ["x", "y", "font-size", "fill"], Dt = ["stroke", "x1", "x2", "y1", "y2"], Ht = { key: 2 }, Bt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], Wt = ["x", "y", "width", "height", "stroke", "stroke-width", "stroke-linecap", "stroke-linejoin", "stroke-dasharray"], Et = { key: 4 }, Yt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], qt = ["fill", "font-size", "transform"], Xt = ["x1", "x2", "y1", "y2", "stroke"], Ut = ["x", "y", "font-size", "fill"], Zt = ["x1", "x2", "y1", "y2", "stroke"], Jt = ["x", "y", "font-size", "fill"], Qt = ["width", "x", "y"], Kt = { style: { width: "100%" } }, jt = { key: 0 }, $t = ["id"], ei = ["fill"], ti = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], ii = ["x", "y", "font-size", "fill"], ri = ["d", "stroke", "stroke-width", "stroke-dasharray"], ai = ["d", "stroke", "stroke-width", "stroke-dasharray"], li = { key: 5 }, si = { key: 0 }, ni = ["d", "fill"], hi = ["d", "fill"], oi = ["d", "fill"], ci = ["d", "fill"], di = ["d", "stroke", "stroke-width", "stroke-dasharray"], ui = ["d", "stroke", "stroke-width", "stroke-dasharray"], gi = ["width", "x", "y"], fi = { style: { width: "100%" } }, Ii = { key: 3 }, mi = ["id"], Ni = ["fill"], xi = ["x1", "x2", "y1", "y2", "stroke", "marker-end"], bi = ["x", "y", "font-size", "fill"], Fi = { key: 6 }, _i = ["x", "y", "font-size", "fill"], Ai = ["x", "y", "font-size", "fill", "font-weight"], yi = { key: 7 }, Li = ["x", "y", "font-size", "fill"], Ci = ["x", "y"], Si = ["x", "y"], ki = { key: 8 }, wi = ["x", "y", "font-size", "fill"], Oi = ["x", "y"], Gi = ["x", "y"], vi = ["x", "y", "font-size", "fill", "innerHTML"], zi = ["x", "y", "font-size", "fill", "innerHTML"], Mi = ["x", "y", "font-size", "fill", "innerHTML"], pi = ["x", "y", "font-size", "fill", "innerHTML"], Ti = ["x", "y", "width", "height", "fill", "onMouseenter"], Pi = ["font-size", "fill", "transform"], Vi = ["x", "y", "font-size", "fill"], Ri = { key: 10 }, Di = ["text-anchor", "font-size", "fill", "transform", "onClick"], Hi = ["x", "y", "height", "width", "onMouseenter", "onClick"], Bi = { key: 11 }, Wi = ["x", "y"], Ei = ["cx", "cy", "r", "fill"], Yi = {
  key: 5,
  class: "vue-data-ui-watermark"
}, qi = ["onClick"], Xi = {
  key: 0,
  viewBox: "0 0 20 12",
  height: "14",
  width: "20"
}, Ui = ["stroke", "fill"], Zi = {
  key: 1,
  viewBox: "0 0 40 40",
  height: "14",
  width: "14"
}, Ji = ["fill"], Qi = ["fill"], Ki = {
  key: 2,
  viewBox: "0 0 12 12",
  height: "14",
  width: "14"
}, ji = {
  key: 9,
  ref: "chartLegend"
}, $i = {
  key: 10,
  ref: "source",
  dir: "auto"
}, er = {
  style: { display: "flex", "flex-direction": "row", gap: "6px", "align-items": "center", "padding-left": "6px" },
  "data-html2canvas-ignore": ""
}, tr = ["innerHTML"];
function ir(i, l, o, d, t, e) {
  const N = R("PenAndPaper"), _ = R("Title"), O = R("UserOptions"), I = R("PackageVersion"), b = R("Shape"), V = R("Skeleton"), v = R("Slicer"), z = R("Tooltip"), G = R("BaseIcon"), F = R("TableSparkline"), C = R("DataTable"), T = R("Accordion");
  return a(), s("div", {
    id: `vue-ui-xy_${t.uniqueId}`,
    class: D(`vue-ui-xy ${t.isFullscreen ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.FINAL_CONFIG.useCssAnimation ? "" : "vue-ui-dna"}`),
    ref: "chart",
    style: L(`background:${e.FINAL_CONFIG.chart.backgroundColor}; color:${e.FINAL_CONFIG.chart.color};width:100%;font-family:${e.FINAL_CONFIG.chart.fontFamily};${e.FINAL_CONFIG.responsive ? "height: 100%" : ""}`),
    onMouseenter: l[7] || (l[7] = () => e.setUserOptionsVisibility(!0)),
    onMouseleave: l[8] || (l[8] = () => e.setUserOptionsVisibility(!1))
  }, [
    e.FINAL_CONFIG.chart.userOptions.buttons.annotator ? (a(), B(N, {
      key: 0,
      parent: i.$refs.chart,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      active: t.isAnnotator,
      onClose: e.toggleAnnotator
    }, null, 8, ["parent", "backgroundColor", "color", "active", "onClose"])) : c("", !0),
    e.hasOptionsNoTitle ? (a(), s("div", je, null, 512)) : c("", !0),
    e.FINAL_CONFIG.chart.title.show ? (a(), s("div", {
      key: 2,
      ref: "chartTitle",
      class: "vue-ui-xy-title",
      style: L(`font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      (a(), B(_, {
        key: `title_${t.titleStep}`,
        config: {
          title: {
            cy: "xy-div-title",
            ...e.FINAL_CONFIG.chart.title
          },
          subtitle: {
            cy: "xy-div-subtitle",
            ...e.FINAL_CONFIG.chart.title.subtitle
          }
        }
      }, null, 8, ["config"]))
    ], 4)) : c("", !0),
    e.FINAL_CONFIG.chart.userOptions.show && e.isDataset && (t.keepUserOptionState || t.userOptionsVisible) ? (a(), B(O, {
      ref: "defails",
      key: `user_options_${t.step}`,
      backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
      color: e.FINAL_CONFIG.chart.color,
      isPrinting: t.isPrinting,
      isImaging: t.isImaging,
      uid: t.uniqueId,
      hasTooltip: e.FINAL_CONFIG.chart.userOptions.buttons.tooltip && e.FINAL_CONFIG.chart.tooltip.show,
      hasPdf: e.FINAL_CONFIG.chart.userOptions.buttons.pdf,
      hasXls: e.FINAL_CONFIG.chart.userOptions.buttons.csv,
      hasImg: e.FINAL_CONFIG.chart.userOptions.buttons.img,
      hasLabel: e.FINAL_CONFIG.chart.userOptions.buttons.labels,
      hasTable: e.FINAL_CONFIG.chart.userOptions.buttons.table,
      hasStack: o.dataset.length > 1 && e.FINAL_CONFIG.chart.userOptions.buttons.stack,
      hasFullscreen: e.FINAL_CONFIG.chart.userOptions.buttons.fullscreen,
      isStacked: t.mutableConfig.isStacked,
      isFullscreen: t.isFullscreen,
      chartElement: i.$refs.chart,
      position: e.FINAL_CONFIG.chart.userOptions.position,
      isTooltip: t.mutableConfig.showTooltip,
      titles: { ...e.FINAL_CONFIG.chart.userOptions.buttonTitles },
      hasAnnotator: e.FINAL_CONFIG.chart.userOptions.buttons.annotator,
      isAnnotation: t.isAnnotator,
      onToggleFullscreen: e.toggleFullscreen,
      onGeneratePdf: e.generatePdf,
      onGenerateCsv: e.generateCsv,
      onGenerateImage: e.generateImage,
      onToggleTable: e.toggleTable,
      onToggleLabels: e.toggleLabels,
      onToggleStack: e.toggleStack,
      onToggleTooltip: e.toggleTooltip,
      onToggleAnnotator: e.toggleAnnotator,
      style: L({
        visibility: t.keepUserOptionState ? t.userOptionsVisible ? "visible" : "hidden" : "visible"
      })
    }, Ee({ _: 2 }, [
      i.$slots.optionTooltip ? {
        name: "optionTooltip",
        fn: P(() => [
          k(i.$slots, "optionTooltip", {}, void 0, !0)
        ]),
        key: "0"
      } : void 0,
      i.$slots.optionPdf ? {
        name: "optionPdf",
        fn: P(() => [
          k(i.$slots, "optionPdf", {}, void 0, !0)
        ]),
        key: "1"
      } : void 0,
      i.$slots.optionCsv ? {
        name: "optionCsv",
        fn: P(() => [
          k(i.$slots, "optionCsv", {}, void 0, !0)
        ]),
        key: "2"
      } : void 0,
      i.$slots.optionImg ? {
        name: "optionImg",
        fn: P(() => [
          k(i.$slots, "optionImg", {}, void 0, !0)
        ]),
        key: "3"
      } : void 0,
      i.$slots.optionTable ? {
        name: "optionTable",
        fn: P(() => [
          k(i.$slots, "optionTable", {}, void 0, !0)
        ]),
        key: "4"
      } : void 0,
      i.$slots.optionLabels ? {
        name: "optionLabels",
        fn: P(() => [
          k(i.$slots, "optionLabels", {}, void 0, !0)
        ]),
        key: "5"
      } : void 0,
      i.$slots.optionStack ? {
        name: "optionStack",
        fn: P(() => [
          k(i.$slots, "optionStack", {}, void 0, !0)
        ]),
        key: "6"
      } : void 0,
      i.$slots.optionFullscreen ? {
        name: "optionFullscreen",
        fn: P(({ toggleFullscreen: r, isFullscreen: h }) => [
          k(i.$slots, "optionFullscreen", W(E({ toggleFullscreen: r, isFullscreen: h })), void 0, !0)
        ]),
        key: "7"
      } : void 0,
      i.$slots.optionAnnotator ? {
        name: "optionAnnotator",
        fn: P(({ toggleAnnotator: r, isAnnotator: h }) => [
          k(i.$slots, "optionAnnotator", W(E({ toggleAnnotator: r, isAnnotator: h })), void 0, !0)
        ]),
        key: "8"
      } : void 0
    ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasTooltip", "hasPdf", "hasXls", "hasImg", "hasLabel", "hasTable", "hasStack", "hasFullscreen", "isStacked", "isFullscreen", "chartElement", "position", "isTooltip", "titles", "hasAnnotator", "isAnnotation", "onToggleFullscreen", "onGeneratePdf", "onGenerateCsv", "onGenerateImage", "onToggleTable", "onToggleLabels", "onToggleStack", "onToggleTooltip", "onToggleAnnotator", "style"])) : c("", !0),
    e.isDataset ? (a(), s("svg", {
      key: 4,
      xmlns: "http://www.w3.org/2000/svg",
      class: D([{ "vue-data-ui-fullscreen--on": t.isFullscreen, "vue-data-ui-fulscreen--off": !t.isFullscreen }, "vue-ui-xy-svg"]),
      width: "100%",
      viewBox: t.viewBox,
      style: L(`background: transparent; color:${e.FINAL_CONFIG.chart.color}; font-family:${e.FINAL_CONFIG.chart.fontFamily}`)
    }, [
      q(I),
      i.$slots["chart-background"] ? (a(), s("foreignObject", {
        key: 0,
        x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
        y: e.drawingArea.top,
        width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
        height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
        style: {
          pointerEvents: "none"
        }
      }, [
        k(i.$slots, "chart-background", {}, void 0, !0)
      ], 8, et)) : c("", !0),
      e.maxSeries > 0 ? (a(), s("g", tt, [
        u("g", it, [
          e.FINAL_CONFIG.chart.grid.labels.xAxis.showBaseline ? (a(), s("line", {
            key: 0,
            stroke: e.FINAL_CONFIG.chart.grid.stroke,
            "stroke-width": "1",
            x1: e.drawingArea.left + e.xPadding,
            x2: e.drawingArea.right - e.xPadding,
            y1: e.forceValidValue(e.drawingArea.bottom),
            y2: e.forceValidValue(e.drawingArea.bottom),
            "stroke-linecap": "round"
          }, null, 8, rt)) : c("", !0),
          t.mutableConfig.useIndividualScale ? e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (a(!0), s(f, { key: 2 }, m(e.allScales, (r) => (a(), s("g", null, [
            r.id === t.selectedScale && r.yLabels.length ? (a(!0), s(f, { key: 0 }, m(r.yLabels, (h) => (a(), s("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.forceValidValue(h.y),
              y2: e.forceValidValue(h.y),
              stroke: r.color,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, nt))), 256)) : r.yLabels.length ? (a(!0), s(f, { key: 1 }, m(r.yLabels, (h) => (a(), s("line", {
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.right - e.xPadding,
              y1: e.forceValidValue(h.y),
              y2: e.forceValidValue(h.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": 0.5,
              "stroke-linecap": "round"
            }, null, 8, ht))), 256)) : c("", !0)
          ]))), 256)) : c("", !0) : (a(), s(f, { key: 1 }, [
            e.FINAL_CONFIG.chart.grid.labels.yAxis.showBaseline ? (a(), s("line", {
              key: 0,
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left + e.xPadding,
              y1: e.forceValidValue(e.drawingArea.top),
              y2: e.forceValidValue(e.drawingArea.bottom),
              "stroke-linecap": "round"
            }, null, 8, at)) : c("", !0),
            e.FINAL_CONFIG.chart.grid.showHorizontalLines ? (a(), s("g", lt, [
              (a(!0), s(f, null, m(e.yLabels, (r) => (a(), s("line", {
                x1: e.drawingArea.left + e.xPadding,
                x2: e.drawingArea.right - e.xPadding,
                y1: e.forceValidValue(r.y),
                y2: e.forceValidValue(r.y),
                stroke: e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-width": 0.5,
                "stroke-linecap": "round"
              }, null, 8, st))), 256))
            ])) : c("", !0)
          ], 64)),
          e.FINAL_CONFIG.chart.grid.showVerticalLines ? (a(), s("g", ot, [
            (a(!0), s(f, null, m(e.maxSeries + (e.FINAL_CONFIG.chart.grid.position === "middle" ? 1 : 0), (r, h) => (a(), s("line", {
              key: `grid_vertical_line_${h}`,
              x1: e.drawingArea.width / e.maxSeries * h + e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.width / e.maxSeries * h + e.drawingArea.left + e.xPadding,
              y1: e.forceValidValue(e.drawingArea.top),
              y2: e.forceValidValue(e.drawingArea.bottom),
              "stroke-width": "0.5",
              stroke: e.FINAL_CONFIG.chart.grid.stroke
            }, null, 8, ct))), 128))
          ])) : c("", !0)
        ]),
        (a(!0), s(f, null, m(e.barSet, (r, h) => (a(), s("defs", {
          key: `def_rect_${h}`
        }, [
          u("linearGradient", {
            id: `rectGradient_pos_${h}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": r.color
            }, null, 8, ut),
            u("stop", {
              offset: "62%",
              "stop-color": `${e.shiftHue(r.color, 0.02)}`
            }, null, 8, gt),
            u("stop", {
              offset: "100%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, ft)
          ], 8, dt),
          u("linearGradient", {
            id: `rectGradient_neg_${h}_${t.uniqueId}`,
            x2: "0%",
            y2: "100%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, mt),
            u("stop", {
              offset: "38%",
              "stop-color": `${e.shiftHue(r.color, 0.02)}`
            }, null, 8, Nt),
            u("stop", {
              offset: "100%",
              "stop-color": r.color
            }, null, 8, xt)
          ], 8, It)
        ]))), 128)),
        (a(!0), s(f, null, m(e.plotSet, (r, h) => (a(), s("defs", {
          key: `def_plot_${h}`
        }, [
          u("radialGradient", {
            id: `plotGradient_${h}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, Ft),
            u("stop", {
              offset: "100%",
              "stop-color": r.color
            }, null, 8, _t)
          ], 8, bt)
        ]))), 128)),
        (a(!0), s(f, null, m(e.lineSet, (r, h) => (a(), s("defs", {
          key: `def_line_${h}`
        }, [
          u("radialGradient", {
            id: `lineGradient_${h}_${t.uniqueId}`,
            cx: "50%",
            cy: "50%",
            r: "50%",
            fx: "50%",
            fy: "50%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.shiftHue(r.color, 0.05)}`
            }, null, 8, yt),
            u("stop", {
              offset: "100%",
              "stop-color": r.color
            }, null, 8, Lt)
          ], 8, At),
          u("linearGradient", {
            id: `areaGradient_${h}_${t.uniqueId}`,
            x1: "0%",
            x2: "100%",
            y1: "0%",
            y2: "0%"
          }, [
            u("stop", {
              offset: "0%",
              "stop-color": `${e.setOpacity(e.shiftHue(r.color, 0.03), e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, St),
            u("stop", {
              offset: "100%",
              "stop-color": `${e.setOpacity(r.color, e.FINAL_CONFIG.line.area.opacity)}`
            }, null, 8, kt)
          ], 8, Ct)
        ]))), 128)),
        (a(!0), s(f, null, m(e.highlightAreas, (r) => (a(), s("g", null, [
          r.show ? (a(!0), s(f, { key: 0 }, m(r.span, (h, n) => (a(), s("g", null, [
            u("rect", {
              style: L({
                transition: "none",
                opacity: r.from + n >= t.slicer.start && r.from + n <= t.slicer.end - 1 ? 1 : 0
              }),
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (r.from + n - t.slicer.start),
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: e.setOpacity(r.color, r.opacity)
            }, null, 12, wt),
            r.caption.text && n === 0 ? (a(), s("foreignObject", {
              key: 0,
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * (r.from + n - t.slicer.start) - (r.caption.width === "auto" ? 0 : r.caption.width / 2 - e.drawingArea.width / e.maxSeries * r.span / 2),
              y: e.drawingArea.top + r.caption.offsetY,
              style: L({
                overflow: "visible",
                opacity: r.to >= t.slicer.start && r.from < t.slicer.end ? 1 : 0
              }),
              height: "1",
              width: r.caption.width === "auto" ? e.drawingArea.width / e.maxSeries * r.span : r.caption.width
            }, [
              u("div", {
                style: L(`padding:${r.caption.padding}px;text-align:${r.caption.textAlign};font-size:${r.caption.fontSize}px;color:${r.caption.color};font-weight:${r.caption.bold ? "bold" : "normal"}`)
              }, w(r.caption.text), 5)
            ], 12, Ot)) : c("", !0)
          ]))), 256)) : c("", !0)
        ]))), 256)),
        u("g", null, [
          (a(!0), s(f, null, m(e.maxSeries, (r, h) => (a(), s("g", {
            key: `tooltip_trap_highlighter_${h}`
          }, [
            u("rect", {
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: [t.selectedMinimapIndex, t.selectedSerieIndex, t.selectedRowIndex].includes(h) ? e.setOpacity(e.FINAL_CONFIG.chart.highlighter.color, e.FINAL_CONFIG.chart.highlighter.opacity) : "transparent"
            }, null, 8, Gt)
          ]))), 128))
        ]),
        e.barSet.length ? (a(!0), s(f, { key: 0 }, m(e.barSet, (r, h) => (a(), s("g", {
          key: `serie_bar_${h}`,
          class: D(`serie_bar_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (a(!0), s(f, null, m(r.plots, (n, g) => (a(), s("g", {
            key: `bar_plot_${h}_${g}`
          }, [
            e.canShowValue(n.value) ? (a(), s("rect", {
              key: 0,
              x: e.calcRectX(n),
              y: t.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: t.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: e.FINAL_CONFIG.bar.useGradient ? n.value >= 0 ? `url(#rectGradient_pos_${h}_${t.uniqueId})` : `url(#rectGradient_neg_${h}_${t.uniqueId})` : r.color,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? r.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, vt)) : c("", !0),
            e.canShowValue(n.value) && i.$slots.pattern ? (a(), s("rect", {
              key: 1,
              x: e.calcRectX(n),
              y: t.mutableConfig.useIndividualScale ? e.calcIndividualRectY(n) : e.calcRectY(n),
              height: t.mutableConfig.useIndividualScale ? Math.abs(e.calcIndividualHeight(n)) : Math.abs(e.calcRectHeight(n)),
              width: e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap),
              rx: e.FINAL_CONFIG.bar.borderRadius,
              fill: `url(#pattern_${t.uniqueId}_${r.slotAbsoluteIndex})`,
              stroke: e.FINAL_CONFIG.bar.border.useSerieColor ? r.color : e.FINAL_CONFIG.bar.border.stroke,
              "stroke-width": e.FINAL_CONFIG.bar.border.strokeWidth
            }, null, 8, zt)) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (a(), s("foreignObject", {
              key: 2,
              style: { overflow: "visible" },
              height: "12",
              width: (e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) < 0 ? 1e-5 : e.calcRectWidth() - (t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? 0 : e.barPeriodGap) / 2) + e.FINAL_CONFIG.chart.comments.width,
              x: e.calcRectX(n) - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: e.checkNaN(n.y) + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              k(i.$slots, "plot-comment", {
                plot: { ...n, color: r.color, seriesIndex: h, datapointIndex: g }
              }, void 0, !0)
            ], 8, Mt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(r, "useProgression") && r.useProgression === !0 && !isNaN(e.calcLinearProgression(r.plots).trend) ? (a(), s("g", pt, [
            u("defs", null, [
              u("marker", {
                id: `bar_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: r.color
                }, null, 8, Pt)
              ], 8, Tt)
            ]),
            r.plots.length > 1 ? (a(), s("line", {
              key: 0,
              x1: e.calcLinearProgression(r.plots).x1,
              x2: e.calcLinearProgression(r.plots).x2,
              y1: e.forceValidValue(e.calcLinearProgression(r.plots).y1),
              y2: e.forceValidValue(e.calcLinearProgression(r.plots).y2),
              "stroke-width": 1,
              stroke: r.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#bar_arrow_${h})`
            }, null, 8, Vt)) : c("", !0),
            r.plots.length > 1 ? (a(), s("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(r.plots).x2,
              y: e.calcLinearProgression(r.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: r.color
            }, w(e.dataLabel({
              v: e.calcLinearProgression(r.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, Rt)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)) : c("", !0),
        !t.mutableConfig.useIndividualScale && e.FINAL_CONFIG.chart.grid.labels.zeroLine.show ? (a(), s("line", {
          key: 1,
          stroke: e.FINAL_CONFIG.chart.grid.stroke,
          "stroke-width": "1",
          x1: e.drawingArea.left + e.xPadding,
          x2: e.drawingArea.right - e.xPadding,
          y1: e.forceValidValue(e.zero),
          y2: e.forceValidValue(e.zero),
          "stroke-linecap": "round"
        }, null, 8, Dt)) : c("", !0),
        e.FINAL_CONFIG.chart.highlighter.useLine && (![null, void 0].includes(t.selectedSerieIndex) || ![null, void 0].includes(t.selectedMinimapIndex)) ? (a(), s("g", Ht, [
          u("line", {
            x1: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            x2: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            y1: e.forceValidValue(e.drawingArea.top),
            y2: e.forceValidValue(e.drawingArea.bottom),
            stroke: e.FINAL_CONFIG.chart.highlighter.color,
            "stroke-width": e.FINAL_CONFIG.chart.highlighter.lineWidth,
            "stroke-dasharray": e.FINAL_CONFIG.chart.highlighter.lineDasharray,
            "stroke-linecap": "round",
            style: { transition: "none !important", animation: "none !important", "pointer-events": "none" }
          }, null, 8, Bt)
        ])) : c("", !0),
        e.FINAL_CONFIG.chart.grid.frame.show ? (a(), s("rect", {
          key: 3,
          style: { pointerEvents: "none", transition: "none" },
          x: e.drawingArea.left + e.xPadding < 0 ? 0 : e.drawingArea.left + e.xPadding,
          y: e.drawingArea.top,
          width: e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries) < 0 ? 0 : e.drawingArea.width - (e.FINAL_CONFIG.chart.grid.position === "middle" ? 0 : e.drawingArea.width / e.maxSeries),
          height: e.drawingArea.height < 0 ? 0 : e.drawingArea.height,
          fill: "transparent",
          stroke: e.FINAL_CONFIG.chart.grid.frame.stroke,
          "stroke-width": e.FINAL_CONFIG.chart.grid.frame.strokeWidth,
          "stroke-linecap": e.FINAL_CONFIG.chart.grid.frame.strokeLinecap,
          "stroke-linejoin": e.FINAL_CONFIG.chart.grid.frame.strokeLinejoin,
          "stroke-dasharray": e.FINAL_CONFIG.chart.grid.frame.strokeDasharray
        }, null, 8, Wt)) : c("", !0),
        e.FINAL_CONFIG.chart.grid.labels.show ? (a(), s("g", Et, [
          t.mutableConfig.useIndividualScale ? (a(), s(f, { key: 0 }, [
            (a(!0), s(f, null, m(e.allScales, (r) => (a(), s("g", null, [
              u("line", {
                x1: r.x + e.xPadding,
                x2: r.x + e.xPadding,
                y1: t.mutableConfig.isStacked ? e.forceValidValue(e.drawingArea.bottom - r.yOffset - r.individualHeight) : e.forceValidValue(e.drawingArea.top),
                y2: t.mutableConfig.isStacked ? e.forceValidValue(e.drawingArea.bottom - r.yOffset) : e.forceValidValue(e.drawingArea.bottom),
                stroke: r.color,
                "stroke-width": e.FINAL_CONFIG.chart.grid.stroke,
                "stroke-linecap": "round",
                style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
              }, null, 12, Yt)
            ]))), 256)),
            (a(!0), s(f, null, m(e.allScales, (r) => (a(), s("g", {
              style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.3 : 1};transition:opacity 0.2s ease-in-out`)
            }, [
              u("text", {
                fill: r.color,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "middle",
                transform: `translate(${r.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + 5 + e.xPadding}, ${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset - r.individualHeight / 2 : e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`
              }, w(r.name) + " " + w(r.scaleLabel ? `- ${r.scaleLabel}` : ""), 9, qt),
              (a(!0), s(f, null, m(r.yLabels, (h, n) => (a(), s("line", {
                x1: r.x - 3 + e.xPadding,
                x2: r.x + e.xPadding,
                y1: e.forceValidValue(h.y),
                y2: e.forceValidValue(h.y),
                stroke: r.color,
                "stroke-width": 1,
                "stroke-linecap": "round"
              }, null, 8, Xt))), 256)),
              (a(!0), s(f, null, m(r.yLabels, (h, n) => (a(), s("text", {
                x: r.x - 5 + e.xPadding,
                y: e.forceValidValue(h.y) + t.fontSizes.dataLabels / 3,
                "font-size": t.fontSizes.dataLabels,
                "text-anchor": "end",
                fill: r.color
              }, w(e.applyDataLabel(
                e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
                h.value,
                e.dataLabel({
                  p: h.prefix,
                  v: h.value,
                  s: h.suffix,
                  r: 1
                }),
                { datapoint: h.datapoint, seriesIndex: n }
              )), 9, Ut))), 256))
            ], 4))), 256))
          ], 64)) : (a(!0), s(f, { key: 1 }, m(e.yLabels, (r, h) => (a(), s("g", {
            key: `yLabel_${h}`
          }, [
            e.canShowValue(r) && r.value >= e.niceScale.min && r.value <= e.niceScale.max ? (a(), s("line", {
              key: 0,
              x1: e.drawingArea.left + e.xPadding,
              x2: e.drawingArea.left - 5 + e.xPadding,
              y1: e.forceValidValue(r.y),
              y2: e.forceValidValue(r.y),
              stroke: e.FINAL_CONFIG.chart.grid.stroke,
              "stroke-width": "1",
              "stroke-linecap": "round"
            }, null, 8, Zt)) : c("", !0),
            r.value >= e.niceScale.min && r.value <= e.niceScale.max ? (a(), s("text", {
              key: 1,
              x: e.drawingArea.left - 7 + e.xPadding,
              y: e.checkNaN(r.y + t.fontSizes.dataLabels / 3),
              "font-size": t.fontSizes.dataLabels,
              "text-anchor": "end",
              fill: e.FINAL_CONFIG.chart.grid.labels.color
            }, w(e.canShowValue(r.value) ? e.applyDataLabel(
              e.FINAL_CONFIG.chart.grid.labels.yAxis.formatter,
              r.value,
              e.dataLabel({
                p: r.prefix,
                v: r.value,
                s: r.suffix,
                r: 1
              })
            ) : ""), 9, Jt)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        (a(!0), s(f, null, m(e.plotSet, (r, h) => (a(), s("g", {
          key: `serie_plot_${h}`,
          class: D(`serie_plot_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (a(!0), s(f, null, m(r.plots, (n, g) => (a(), s("g", {
            key: `circle_plot_${h}_${g}`
          }, [
            n && e.canShowValue(n.value) ? (a(), B(b, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle",
              color: e.FINAL_CONFIG.plot.useGradient ? `url(#plotGradient_${h}_${t.uniqueId})` : e.FINAL_CONFIG.plot.dot.useSerieColor ? r.color : e.FINAL_CONFIG.plot.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === g || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === g ? (t.plotRadii.plot || 6) * 1.5 : t.plotRadii.plot || 6,
              stroke: e.FINAL_CONFIG.plot.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : r.color,
              strokeWidth: e.FINAL_CONFIG.plot.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (a(), s("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              u("div", Kt, [
                k(i.$slots, "plot-comment", {
                  plot: { ...n, color: r.color, seriesIndex: h, datapointIndex: g }
                }, void 0, !0)
              ])
            ], 8, Qt)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(r, "useProgression") && r.useProgression === !0 && !isNaN(e.calcLinearProgression(r.plots).trend) ? (a(), s("g", jt, [
            u("defs", null, [
              u("marker", {
                id: `plot_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: r.color
                }, null, 8, ei)
              ], 8, $t)
            ]),
            r.plots.length > 1 ? (a(), s("line", {
              key: 0,
              x1: e.calcLinearProgression(r.plots).x1,
              x2: e.calcLinearProgression(r.plots).x2,
              y1: e.forceValidValue(e.calcLinearProgression(r.plots).y1),
              y2: e.forceValidValue(e.calcLinearProgression(r.plots).y2),
              "stroke-width": 1,
              stroke: r.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#plot_arrow_${h})`
            }, null, 8, ti)) : c("", !0),
            r.plots.length > 1 ? (a(), s("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(r.plots).x2,
              y: e.calcLinearProgression(r.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: r.color
            }, w(e.dataLabel({
              v: e.calcLinearProgression(r.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, ii)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (a(!0), s(f, null, m(e.lineSet, (r, h) => (a(), s("g", {
          key: `serie_line_${h}`,
          class: D(`serie_line_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          r.smooth && r.plots.length > 1 ? (a(), s("path", {
            key: 0,
            d: `M${r.curve}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none"
          }, null, 8, ri)) : r.plots.length > 1 ? (a(), s("path", {
            key: 1,
            d: `M${r.straight}`,
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth + 1,
            "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none",
            "stroke-linecap": "round",
            "stroke-linejoin": "round"
          }, null, 8, ai)) : c("", !0)
        ], 6))), 128)),
        i.$slots.pattern ? (a(), s("defs", li, [
          (a(!0), s(f, null, m(e.safeDataset, (r, h) => k(i.$slots, "pattern", Ye({
            key: `serie_pattern_slot_${h}`
          }, { ...r, seriesIndex: r.slotAbsoluteIndex, patternId: `pattern_${t.uniqueId}_${h}` }), void 0, !0)), 128))
        ])) : c("", !0),
        (a(!0), s(f, null, m(e.lineSet, (r, h) => (a(), s("g", {
          key: `serie_line_${h}`,
          class: D(`serie_line_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          r.useArea && r.plots.length > 1 ? (a(), s("g", si, [
            r.smooth ? (a(), s(f, { key: 0 }, [
              u("path", {
                d: `M ${r.plots[0] ? r.plots[0].x : Math.min(...r.plots.filter((n) => !!n).map((n) => n.x))},${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} ${r.curve} L ${r.plots.at(-1) ? r.plots.at(-1).x : e.drawingArea.left + e.slot.line * h + e.slot.line / 2},${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} Z`,
                fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${h}_${t.uniqueId})` : e.setOpacity(r.color, e.FINAL_CONFIG.line.area.opacity)
              }, null, 8, ni),
              i.$slots.pattern ? (a(), s("path", {
                key: 0,
                d: `M ${r.plots[0] ? r.plots[0].x : Math.min(...r.plots.filter((n) => !!n).map((n) => n.x))},${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} ${r.curve} L ${r.plots.at(-1) ? r.plots.at(-1).x : e.drawingArea.left + e.slot.line * h + e.slot.line / 2},${t.mutableConfig.isStacked ? e.drawingArea.bottom - r.yOffset : e.drawingArea.bottom} Z`,
                fill: `url(#pattern_${t.uniqueId}_${r.slotAbsoluteIndex})`
              }, null, 8, hi)) : c("", !0)
            ], 64)) : (a(), s(f, { key: 1 }, [
              u("path", {
                d: `M${r.area}Z`,
                fill: e.FINAL_CONFIG.line.area.useGradient ? `url(#areaGradient_${h}_${t.uniqueId})` : e.setOpacity(r.color, e.FINAL_CONFIG.line.area.opacity)
              }, null, 8, oi),
              i.$slots.pattern ? (a(), s("path", {
                key: 0,
                d: `M${r.area}Z`,
                fill: `url(#pattern_${t.uniqueId}_${r.slotAbsoluteIndex})`
              }, null, 8, ci)) : c("", !0)
            ], 64))
          ])) : c("", !0),
          r.smooth && r.plots.length > 1 ? (a(), s("path", {
            key: 1,
            d: `M${r.curve}`,
            stroke: r.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none",
            "stroke-linecap": "round"
          }, null, 8, di)) : r.plots.length > 1 ? (a(), s("path", {
            key: 2,
            d: `M${r.straight}`,
            stroke: r.color,
            "stroke-width": e.FINAL_CONFIG.line.strokeWidth,
            "stroke-dasharray": r.dashed ? e.FINAL_CONFIG.line.strokeWidth * 2 : 0,
            fill: "none",
            "stroke-linecap": "round",
            "stroke-linejoin": "round"
          }, null, 8, ui)) : c("", !0),
          (a(!0), s(f, null, m(r.plots, (n, g) => (a(), s("g", {
            key: `circle_line_${h}_${g}`
          }, [
            !e.optimize.linePlot && n && e.canShowValue(n.value) || e.optimize.linePlot && n && e.canShowValue(n.value) && (t.selectedSerieIndex !== null && t.selectedSerieIndex === g || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === g) ? (a(), B(b, {
              key: 0,
              shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle",
              color: e.FINAL_CONFIG.line.useGradient ? `url(#lineGradient_${h}_${t.uniqueId})` : e.FINAL_CONFIG.line.dot.useSerieColor ? r.color : e.FINAL_CONFIG.line.dot.fill,
              plot: { x: e.checkNaN(n.x), y: e.checkNaN(n.y) },
              radius: t.selectedSerieIndex !== null && t.selectedSerieIndex === g || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === g ? (t.plotRadii.line || 6) * 1.5 : t.plotRadii.line || 6,
              stroke: e.FINAL_CONFIG.line.dot.useSerieColor ? e.FINAL_CONFIG.chart.backgroundColor : r.color,
              strokeWidth: e.FINAL_CONFIG.line.dot.strokeWidth
            }, null, 8, ["shape", "color", "plot", "radius", "stroke", "strokeWidth"])) : c("", !0),
            n.comment && e.FINAL_CONFIG.chart.comments.show ? (a(), s("foreignObject", {
              key: 1,
              style: { overflow: "visible" },
              height: "12",
              width: e.FINAL_CONFIG.chart.comments.width,
              x: n.x - e.FINAL_CONFIG.chart.comments.width / 2 + e.FINAL_CONFIG.chart.comments.offsetX,
              y: n.y + e.FINAL_CONFIG.chart.comments.offsetY + 6
            }, [
              u("div", fi, [
                k(i.$slots, "plot-comment", {
                  plot: { ...n, color: r.color, seriesIndex: h, datapointIndex: g }
                }, void 0, !0)
              ])
            ], 8, gi)) : c("", !0)
          ]))), 128)),
          Object.hasOwn(r, "useProgression") && r.useProgression === !0 && !isNaN(e.calcLinearProgression(r.plots).trend) ? (a(), s("g", Ii, [
            u("defs", null, [
              u("marker", {
                id: `line_arrow_${h}`,
                markerWidth: 7,
                markerHeight: 7,
                refX: "0",
                refY: 7 / 2,
                orient: "auto"
              }, [
                u("polygon", {
                  points: `0 0, 7 ${7 / 2}, 0 7`,
                  fill: r.color
                }, null, 8, Ni)
              ], 8, mi)
            ]),
            r.plots.length > 1 ? (a(), s("line", {
              key: 0,
              x1: e.calcLinearProgression(r.plots).x1,
              x2: e.calcLinearProgression(r.plots).x2,
              y1: e.forceValidValue(e.calcLinearProgression(r.plots).y1),
              y2: e.forceValidValue(e.calcLinearProgression(r.plots).y2),
              "stroke-width": 1,
              stroke: r.color,
              "stroke-dasharray": 2,
              "marker-end": `url(#line_arrow_${h})`
            }, null, 8, xi)) : c("", !0),
            r.plots.length > 1 ? (a(), s("text", {
              key: 1,
              "text-anchor": "middle",
              x: e.calcLinearProgression(r.plots).x2,
              y: e.calcLinearProgression(r.plots).y2 - 6,
              "font-size": t.fontSizes.plotLabels,
              fill: r.color
            }, w(e.dataLabel({
              v: e.calcLinearProgression(r.plots).trend * 100,
              s: "%",
              r: 2
            })), 9, bi)) : c("", !0)
          ])) : c("", !0)
        ], 6))), 128)),
        (e.FINAL_CONFIG.bar.labels.show || e.FINAL_CONFIG.bar.serieName.show) && t.mutableConfig.dataLabels.show ? (a(), s("g", Fi, [
          (a(!0), s(f, null, m(e.barSet, (r, h) => (a(), s("g", {
            key: `xLabel_bar_${h}`,
            class: D(`xLabel_bar_${h}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (a(!0), s(f, null, m(r.plots, (n, g) => (a(), s("g", {
              key: `xLabel_bar_${h}_${g}`
            }, [
              n && (!Object.hasOwn(r, "dataLabels") || r.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === g || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === g) && e.FINAL_CONFIG.bar.labels.show ? (a(), s("text", {
                key: 0,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : e.calcRectX(n) + e.calcRectWidth() / 2 - e.barPeriodGap / 2,
                y: e.checkNaN(n.y) + (n.value >= 0 ? e.FINAL_CONFIG.bar.labels.offsetY : -e.FINAL_CONFIG.bar.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.labels.color
              }, w(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.bar.labels.formatter,
                n.value,
                e.dataLabel({
                  p: r.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: r.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.bar.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: r
                }
              ) : ""), 9, _i)) : c("", !0),
              n && e.FINAL_CONFIG.bar.serieName.show ? (a(), s("text", {
                key: 1,
                x: t.mutableConfig.useIndividualScale && t.mutableConfig.isStacked ? n.x + e.slot.line / 2 : n.x + e.calcRectWidth() * 1.1,
                y: n.y + (n.value > 0 ? e.FINAL_CONFIG.bar.serieName.offsetY : -e.FINAL_CONFIG.bar.serieName.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.bar.serieName.useSerieColor ? r.color : e.FINAL_CONFIG.bar.serieName.color,
                "font-weight": e.FINAL_CONFIG.bar.serieName.bold ? "bold" : "normal"
              }, w(e.FINAL_CONFIG.bar.serieName.useAbbreviation ? e.abbreviate({ source: r.name, length: e.FINAL_CONFIG.bar.serieName.abbreviationSize }) : r.name), 9, Ai)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.plot.labels.show && t.mutableConfig.dataLabels.show ? (a(), s("g", yi, [
          (a(!0), s(f, null, m(e.plotSet, (r, h) => (a(), s("g", {
            key: `xLabel_plot_${h}`,
            class: D(`xLabel_plot_${h}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (a(!0), s(f, null, m(r.plots, (n, g) => (a(), s("g", {
              key: `xLabel_plot_${h}_${g}`
            }, [
              n && !Object.hasOwn(r, "dataLabels") || r.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === g || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === g ? (a(), s("text", {
                key: 0,
                x: n.x,
                y: n.y + e.FINAL_CONFIG.plot.labels.offsetY,
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.plot.labels.color
              }, w(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.plot.labels.formatter,
                n.value,
                e.dataLabel({
                  p: r.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: r.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.plot.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: r
                }
              ) : ""), 9, Li)) : c("", !0),
              n && g === 0 && r.useTag && r.useTag === "start" ? (a(), s("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, w(r.name), 5)
              ], 8, Ci)) : c("", !0),
              n && g === r.plots.length - 1 && r.useTag && r.useTag === "end" ? (a(), s("foreignObject", {
                key: 2,
                x: n.x - r.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, w(r.name), 5)
              ], 8, Si)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        e.FINAL_CONFIG.line.labels.show && t.mutableConfig.dataLabels.show ? (a(), s("g", ki, [
          (a(!0), s(f, null, m(e.lineSet, (r, h) => (a(), s("g", {
            key: `xLabel_line_${h}`,
            class: D(`xLabel_line_${h}`),
            style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
          }, [
            (a(!0), s(f, null, m(r.plots, (n, g) => (a(), s("g", {
              key: `xLabel_line_${h}_${g}`
            }, [
              n && !Object.hasOwn(r, "dataLabels") || r.dataLabels === !0 || t.selectedSerieIndex !== null && t.selectedSerieIndex === g || t.selectedMinimapIndex !== null && t.selectedMinimapIndex === g ? (a(), s("text", {
                key: 0,
                x: n.x,
                y: n.y + (n.value >= 0 ? e.FINAL_CONFIG.line.labels.offsetY : -e.FINAL_CONFIG.line.labels.offsetY * 3),
                "text-anchor": "middle",
                "font-size": t.fontSizes.plotLabels,
                fill: e.FINAL_CONFIG.line.labels.color
              }, w(e.canShowValue(n.value) ? e.applyDataLabel(
                e.FINAL_CONFIG.line.labels.formatter,
                n.value,
                e.dataLabel({
                  p: r.prefix || e.FINAL_CONFIG.chart.labels.prefix,
                  v: n.value,
                  s: r.suffix || e.FINAL_CONFIG.chart.labels.suffix,
                  r: e.FINAL_CONFIG.line.labels.rounding
                }),
                {
                  datapoint: n,
                  serie: r
                }
              ) : ""), 9, wi)) : c("", !0),
              n && g === 0 && r.useTag && r.useTag === "start" ? (a(), s("foreignObject", {
                key: 1,
                x: n.x,
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, w(r.name), 5)
              ], 8, Oi)) : c("", !0),
              n && g === r.plots.length - 1 && r.useTag && r.useTag === "end" ? (a(), s("foreignObject", {
                key: 2,
                x: n.x - r.name.length * (t.fontSizes.plotLabels / 2),
                y: n.y - 20,
                height: 24,
                width: "150",
                style: { overflow: "visible" }
              }, [
                u("div", {
                  style: L(`padding: 3px; background:${e.setOpacity(r.color, 80)};color:${e.adaptColorToBackground(r.color)};width:fit-content;font-size:${t.fontSizes.plotLabels}px;border-radius: 2px;`)
                }, w(r.name), 5)
              ], 8, Gi)) : c("", !0)
            ]))), 128))
          ], 6))), 128))
        ])) : c("", !0),
        (a(!0), s(f, null, m(e.lineSet, (r, h) => (a(), s("g", {
          key: `xLabel_line_${h}`,
          class: D(`xLabel_line_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (a(!0), s(f, null, m(r.plots, (n, g) => (a(), s("g", {
            key: `xLabel_line_${h}_${g}`
          }, [
            n && g === 0 && r.showSerieName && r.showSerieName === "start" ? (a(), s("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: t.fontSizes.plotLabels,
                fill: r.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, vi)) : c("", !0),
            n && g === r.plots.length - 1 && r.showSerieName && r.showSerieName === "end" ? (a(), s("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: t.fontSizes.plotLabels,
                fill: r.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, zi)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        (a(!0), s(f, null, m(e.plotSet, (r, h) => (a(), s("g", {
          key: `xLabel_plot_${h}`,
          class: D(`xLabel_plot_${h}`),
          style: L(`opacity:${t.selectedScale ? t.selectedScale === r.id ? 1 : 0.2 : 1};transition:opacity 0.2s ease-in-out`)
        }, [
          (a(!0), s(f, null, m(r.plots, (n, g) => (a(), s("g", {
            key: `xLabel_plot_${h}_${g}`
          }, [
            n && g === 0 && r.showSerieName && r.showSerieName === "start" ? (a(), s("text", {
              key: 0,
              x: n.x - t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "end",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: t.fontSizes.plotLabels,
                fill: r.color,
                x: n.x - t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, Mi)) : c("", !0),
            n && g === r.plots.length - 1 && r.showSerieName && r.showSerieName === "end" ? (a(), s("text", {
              key: 1,
              x: n.x + t.fontSizes.plotLabels,
              y: n.y,
              "font-size": t.fontSizes.plotLabels,
              "text-anchor": "start",
              fill: r.color,
              innerHTML: e.createTSpans({
                content: r.name,
                fontSize: t.fontSizes.plotLabels,
                fill: r.color,
                x: n.x + t.fontSizes.plotLabels,
                y: n.y,
                maxWords: 2
              })
            }, null, 8, pi)) : c("", !0)
          ]))), 128))
        ], 6))), 128)),
        t.mutableConfig.useIndividualScale && !t.mutableConfig.isStacked ? (a(!0), s(f, { key: 9 }, m(e.allScales, (r) => (a(), s("rect", {
          x: r.x - e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth + e.xPadding,
          y: e.drawingArea.top,
          width: e.FINAL_CONFIG.chart.grid.labels.yAxis.labelWidth,
          height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
          fill: t.selectedScale === r.id ? e.setOpacity(r.color, 20) : "transparent",
          onMouseenter: (h) => t.selectedScale = r.id,
          onMouseleave: l[0] || (l[0] = (h) => t.selectedScale = null)
        }, null, 40, Ti))), 256)) : c("", !0),
        u("g", null, [
          e.FINAL_CONFIG.chart.grid.labels.axis.yLabel && !t.mutableConfig.useIndividualScale ? (a(), s("text", {
            key: 0,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color,
            transform: `translate(${t.fontSizes.yAxis + e.FINAL_CONFIG.chart.grid.labels.axis.yLabelOffsetX}, ${e.drawingArea.top + e.drawingArea.height / 2}) rotate(-90)`,
            "text-anchor": "middle",
            style: { transition: "none" }
          }, w(e.FINAL_CONFIG.chart.grid.labels.axis.yLabel), 9, Pi)) : c("", !0),
          e.FINAL_CONFIG.chart.grid.labels.axis.xLabel ? (a(), s("text", {
            key: 1,
            "text-anchor": "middle",
            x: t.width / 2,
            y: e.drawingArea.bottom + t.fontSizes.yAxis + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.axis.xLabelOffsetY,
            "font-size": t.fontSizes.yAxis,
            fill: e.FINAL_CONFIG.chart.grid.labels.color
          }, w(e.FINAL_CONFIG.chart.grid.labels.axis.xLabel), 9, Vi)) : c("", !0)
        ]),
        e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.show ? (a(), s("g", Ri, [
          i.$slots["time-label"] ? (a(!0), s(f, { key: 0 }, m(e.timeLabels, (r, h) => (a(), s("g", {
            key: `time_label_${h}`
          }, [
            k(i.$slots, "time-label", W(E({
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2,
              y: e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset,
              fontSize: t.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`,
              absoluteIndex: r.absoluteIndex,
              content: r.text,
              textAnchor: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              show: r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (h === 0 || h === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === h && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && h % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0
            })), void 0, !0)
          ]))), 128)) : (a(!0), s(f, { key: 1 }, m(e.timeLabels, (r, h) => (a(), s("g", {
            key: `time_label_${h}`
          }, [
            r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && (h === 0 || h === e.timeLabels.length - 1) && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && t.selectedSerieIndex === h && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo || r && !e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyFirstAndLast && e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.showOnlyAtModulo && h % Math.floor((this.slicer.end - this.slicer.start) / e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.modulo) === 0 ? (a(), s("text", {
              key: 0,
              "text-anchor": e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation > 0 ? "start" : e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation < 0 ? "end" : "middle",
              "font-size": t.fontSizes.xAxis,
              fill: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.color,
              transform: `translate(${e.drawingArea.left + e.drawingArea.width / e.maxSeries * h + e.drawingArea.width / e.maxSeries / 2}, ${e.drawingArea.bottom + t.fontSizes.xAxis * 1.3 + e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.yOffset}), rotate(${e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.rotation})`,
              style: {
                cursor: "pointer"
              },
              onClick: () => e.selectTimeLabel(r, h)
            }, w(r.text || ""), 9, Di)) : c("", !0)
          ]))), 128))
        ])) : c("", !0),
        u("g", null, [
          (a(!0), s(f, null, m(e.maxSeries, (r, h) => (a(), s("g", {
            key: `tooltip_trap_${h}`
          }, [
            u("rect", {
              "data-cy-trap": "",
              x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * h,
              y: e.drawingArea.top,
              height: e.drawingArea.height < 0 ? 10 : e.drawingArea.height,
              width: e.drawingArea.width / e.maxSeries < 0 ? 1e-5 : e.drawingArea.width / e.maxSeries,
              fill: "transparent",
              onMouseenter: (n) => e.toggleTooltipVisibility(!0, h),
              onMouseleave: l[1] || (l[1] = (n) => e.toggleTooltipVisibility(!1)),
              onClick: (n) => e.selectX(h)
            }, null, 40, Hi)
          ]))), 128))
        ]),
        e.FINAL_CONFIG.chart.timeTag.show && (![null, void 0].includes(t.selectedSerieIndex) || ![null, void 0].includes(t.selectedMinimapIndex)) ? (a(), s("g", Bi, [
          (a(), s("foreignObject", {
            x: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) - 100 + e.drawingArea.width / e.maxSeries / 2,
            y: e.drawingArea.bottom,
            width: "200",
            height: "40",
            style: { overflow: "visible !important" }
          }, [
            u("div", {
              class: "vue-ui-xy-time-tag",
              style: L(`width: fit-content;margin: 0 auto;text-align:center;padding:3px 12px;background:${e.FINAL_CONFIG.chart.timeTag.backgroundColor};color:${e.FINAL_CONFIG.chart.timeTag.color};font-size:${e.FINAL_CONFIG.chart.timeTag.fontSize}px`)
            }, w(e.timeLabels[(t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)].text || (t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)), 5)
          ], 8, Wi)),
          u("circle", {
            cx: e.drawingArea.left + e.drawingArea.width / e.maxSeries * ((t.selectedSerieIndex !== null ? t.selectedSerieIndex : 0) || (t.selectedMinimapIndex !== null ? t.selectedMinimapIndex : 0)) + e.drawingArea.width / e.maxSeries / 2,
            cy: e.drawingArea.bottom,
            r: e.FINAL_CONFIG.chart.timeTag.circleMarker.radius,
            fill: e.FINAL_CONFIG.chart.timeTag.circleMarker.color
          }, null, 8, Ei)
        ])) : c("", !0)
      ])) : c("", !0),
      k(i.$slots, "svg", { svg: e.svg }, void 0, !0)
    ], 14, $e)) : c("", !0),
    i.$slots.watermark ? (a(), s("div", Yi, [
      k(i.$slots, "watermark", W(E({ isPrinting: t.isPrinting || t.isImaging })), void 0, !0)
    ])) : c("", !0),
    e.isDataset ? c("", !0) : (a(), B(V, {
      key: 6,
      config: {
        type: "line",
        style: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          line: {
            axis: {
              color: e.FINAL_CONFIG.chart.grid.stroke
            },
            path: {
              color: e.FINAL_CONFIG.chart.grid.stroke,
              strokeWidth: 0.5
            }
          }
        }
      }
    }, null, 8, ["config"])),
    e.FINAL_CONFIG.chart.zoom.show && t.maxX > 6 && e.isDataset ? (a(), B(v, {
      ref: "chartSlicer",
      key: `slicer_${t.slicerStep}`,
      background: e.FINAL_CONFIG.chart.zoom.color,
      fontSize: e.FINAL_CONFIG.chart.zoom.fontSize,
      useResetSlot: e.FINAL_CONFIG.chart.zoom.useResetSlot,
      labelLeft: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.start],
      labelRight: e.FINAL_CONFIG.chart.grid.labels.xAxisLabels.values[t.slicer.end - 1],
      textColor: e.FINAL_CONFIG.chart.color,
      inputColor: e.FINAL_CONFIG.chart.zoom.color,
      selectColor: e.FINAL_CONFIG.chart.zoom.highlightColor,
      borderColor: e.FINAL_CONFIG.chart.backgroundColor,
      minimap: e.minimap,
      smoothMinimap: e.FINAL_CONFIG.chart.zoom.minimap.smooth,
      minimapSelectedColor: e.FINAL_CONFIG.chart.zoom.minimap.selectedColor,
      minimapSelectionRadius: e.FINAL_CONFIG.chart.zoom.minimap.selectionRadius,
      minimapLineColor: e.FINAL_CONFIG.chart.zoom.minimap.lineColor,
      minimapSelectedColorOpacity: e.FINAL_CONFIG.chart.zoom.minimap.selectedColorOpacity,
      minimapSelectedIndex: t.selectedSerieIndex,
      minimapIndicatorColor: e.FINAL_CONFIG.chart.zoom.minimap.indicatorColor,
      verticalHandles: e.FINAL_CONFIG.chart.zoom.minimap.verticalHandles,
      max: t.maxX,
      min: 0,
      valueStart: t.slicer.start,
      valueEnd: t.slicer.end,
      start: t.slicer.start,
      "onUpdate:start": l[2] || (l[2] = (r) => t.slicer.start = r),
      end: t.slicer.end,
      "onUpdate:end": l[3] || (l[3] = (r) => t.slicer.end = r),
      refreshStartPoint: e.FINAL_CONFIG.chart.zoom.startIndex !== null ? e.FINAL_CONFIG.chart.zoom.startIndex : 0,
      refreshEndPoint: e.FINAL_CONFIG.chart.zoom.endIndex !== null ? e.FINAL_CONFIG.chart.zoom.endIndex + 1 : Math.max(...o.dataset.map((r) => e.largestTriangleThreeBucketsArray({ data: r.series, threshold: e.FINAL_CONFIG.downsample.threshold }).length)),
      enableRangeHandles: e.FINAL_CONFIG.chart.zoom.enableRangeHandles,
      enableSelectionDrag: e.FINAL_CONFIG.chart.zoom.enableSelectionDrag,
      onReset: e.refreshSlicer,
      onTrapMouse: e.selectMinimapIndex
    }, {
      "reset-action": P(({ reset: r }) => [
        k(i.$slots, "reset-action", W(E({ reset: r })), void 0, !0)
      ]),
      _: 3
    }, 8, ["background", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "borderColor", "minimap", "smoothMinimap", "minimapSelectedColor", "minimapSelectionRadius", "minimapLineColor", "minimapSelectedColorOpacity", "minimapSelectedIndex", "minimapIndicatorColor", "verticalHandles", "max", "valueStart", "valueEnd", "start", "end", "refreshStartPoint", "refreshEndPoint", "enableRangeHandles", "enableSelectionDrag", "onReset", "onTrapMouse"])) : c("", !0),
    e.FINAL_CONFIG.chart.legend.show ? (a(), s("div", {
      key: 8,
      ref: "chartLegend",
      class: "vue-ui-xy-legend",
      style: L(`font-size:${e.FINAL_CONFIG.chart.legend.fontSize}px`)
    }, [
      (a(!0), s(f, null, m(e.absoluteDataset, (r, h) => (a(), s("div", {
        key: `div_legend_item_${h}`,
        onClick: (n) => e.segregate(r),
        class: D({ "vue-ui-xy-legend-item": !0, "vue-ui-xy-legend-item-segregated": t.segregatedSeries.includes(r.id) })
      }, [
        t.icons[r.type] === "line" ? (a(), s("svg", Xi, [
          u("rect", {
            x: "0",
            y: "7.5",
            rx: "1.5",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            "stroke-width": 0.5,
            height: "3",
            width: "20",
            fill: r.color
          }, null, 8, Ui),
          q(b, {
            plot: { x: 10, y: 9 },
            radius: 4,
            color: r.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle",
            stroke: e.FINAL_CONFIG.chart.backgroundColor,
            strokeWidth: 0.5
          }, null, 8, ["color", "shape", "stroke"])
        ])) : t.icons[r.type] === "bar" ? (a(), s("svg", Zi, [
          t.icons[r.type] === "bar" && i.$slots.pattern ? (a(), s("rect", {
            key: 0,
            x: "0",
            y: "0",
            rx: "1",
            height: "40",
            width: "40",
            stroke: "none",
            fill: r.color
          }, null, 8, Ji)) : c("", !0),
          t.icons[r.type] === "bar" ? (a(), s("rect", {
            key: 1,
            x: "0",
            y: "0",
            rx: "1",
            height: "40",
            width: "40",
            stroke: "none",
            fill: i.$slots.pattern ? `url(#pattern_${t.uniqueId}_${r.slotAbsoluteIndex})` : r.color
          }, null, 8, Qi)) : c("", !0)
        ])) : (a(), s("svg", Ki, [
          q(b, {
            plot: { x: 6, y: 6 },
            radius: 5,
            color: r.color,
            shape: ["triangle", "square", "diamond", "pentagon", "hexagon", "star"].includes(r.shape) ? r.shape : "circle"
          }, null, 8, ["color", "shape"])
        ])),
        u("span", {
          style: L(`color:${e.FINAL_CONFIG.chart.legend.color}`)
        }, w(r.name), 5)
      ], 10, qi))), 128))
    ], 4)) : (a(), s("div", ji, [
      k(i.$slots, "legend", { legend: e.absoluteDataset }, void 0, !0)
    ], 512)),
    i.$slots.source ? (a(), s("div", $i, [
      k(i.$slots, "source", {}, void 0, !0)
    ], 512)) : c("", !0),
    q(z, {
      show: t.mutableConfig.showTooltip && t.isTooltip,
      backgroundColor: e.FINAL_CONFIG.chart.tooltip.backgroundColor,
      color: e.FINAL_CONFIG.chart.tooltip.color,
      fontSize: e.FINAL_CONFIG.chart.tooltip.fontSize,
      borderRadius: e.FINAL_CONFIG.chart.tooltip.borderRadius,
      borderColor: e.FINAL_CONFIG.chart.tooltip.borderColor,
      borderWidth: e.FINAL_CONFIG.chart.tooltip.borderWidth,
      backgroundOpacity: e.FINAL_CONFIG.chart.tooltip.backgroundOpacity,
      position: e.FINAL_CONFIG.chart.tooltip.position,
      offsetY: e.FINAL_CONFIG.chart.tooltip.offsetY,
      parent: i.$refs.chart,
      content: e.tooltipContent,
      isFullscreen: t.isFullscreen,
      isCustom: e.FINAL_CONFIG.chart.tooltip.customFormat && typeof e.FINAL_CONFIG.chart.tooltip.customFormat == "function"
    }, {
      "tooltip-before": P(() => [
        k(i.$slots, "tooltip-before", W(E({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      "tooltip-after": P(() => [
        k(i.$slots, "tooltip-after", W(E({ ...e.dataTooltipSlot })), void 0, !0)
      ]),
      _: 3
    }, 8, ["show", "backgroundColor", "color", "fontSize", "borderRadius", "borderColor", "borderWidth", "backgroundOpacity", "position", "offsetY", "parent", "content", "isFullscreen", "isCustom"]),
    e.isDataset ? (a(), B(T, {
      key: 11,
      hideDetails: "",
      config: {
        open: t.mutableConfig.showTable,
        maxHeight: 1e4,
        body: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        },
        head: {
          backgroundColor: e.FINAL_CONFIG.chart.backgroundColor,
          color: e.FINAL_CONFIG.chart.color
        }
      }
    }, {
      content: P(() => [
        u("div", {
          style: L(`${t.isPrinting ? "" : "max-height:400px"};overflow:auto;width:100%;margin-top:48px`)
        }, [
          u("div", er, [
            qe(u("input", {
              type: "checkbox",
              "onUpdate:modelValue": l[4] || (l[4] = (r) => t.showSparklineTable = r)
            }, null, 512), [
              [Xe, t.showSparklineTable]
            ]),
            u("div", {
              onClick: l[5] || (l[5] = (r) => t.showSparklineTable = !t.showSparklineTable),
              style: { cursor: "pointer" }
            }, [
              q(G, {
                name: "chartLine",
                size: 20,
                stroke: e.FINAL_CONFIG.chart.color
              }, null, 8, ["stroke"])
            ])
          ]),
          t.showSparklineTable ? (a(), B(F, {
            key: `sparkline_${t.segregateStep}`,
            dataset: e.tableSparklineDataset,
            config: e.tableSparklineConfig
          }, null, 8, ["dataset", "config"])) : (a(), B(C, {
            key: `table_${t.tableStep}`,
            colNames: e.dataTable.colNames,
            head: e.dataTable.head,
            body: e.dataTable.body,
            config: e.dataTable.config,
            title: `${e.FINAL_CONFIG.chart.title.text}${e.FINAL_CONFIG.chart.title.subtitle.text ? ` : ${e.FINAL_CONFIG.chart.title.subtitle.text}` : ""}`,
            onClose: l[6] || (l[6] = (r) => t.mutableConfig.showTable = !1)
          }, {
            th: P(({ th: r }) => [
              u("div", { innerHTML: r }, null, 8, tr)
            ]),
            td: P(({ td: r }) => [
              Ue(w(isNaN(Number(r)) ? r : e.dataLabel({
                p: e.FINAL_CONFIG.chart.labels.prefix,
                v: r,
                s: e.FINAL_CONFIG.chart.labels.suffix,
                r: e.FINAL_CONFIG.table.rounding
              })), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ], 4)
      ]),
      _: 1
    }, 8, ["config"])) : c("", !0)
  ], 46, Ke);
}
const br = /* @__PURE__ */ Ze(Qe, [["render", ir], ["__scopeId", "data-v-fb685f15"]]);
export {
  br as default
};
